
CREATE_VARIABLE WORK_COLLATE
SELECT 'COLLATE ' + CAST (SERVERPROPERTY('Collation') AS VARCHAR(100))
GO

--   ,      
UPDATE D SET ZB = 0
FROM {Variable_SmetaDb}.dbo.DEPARTMENTS D 
WHERE
(	
	(TYPE = 4 OR ZB = 1)
	AND NOT EXISTS (SELECT dep_link FROM {Variable_SmetaDb}.dbo.saldo S WHERE S.dep_link = D.LINK)
	AND NOT EXISTS (SELECT dep FROM {Variable_SmetaDb}.dbo.G_PROV G WHERE G.dep = D.LINK)
)
GO

--   ,    
UPDATE D SET ZB = 1
FROM
	{Variable_SmetaDb}.dbo.DEPARTMENTS D
WHERE
	[TYPE] <> 4 AND ZB = 0
	AND
	EXISTS ( SELECT LINK FROM {Variable_SmetaDb}.dbo.G_PROV G WHERE G.DEP = D.LINK)
GO

--   ,           
UPDATE D SET ZB = 0
FROM
	{Variable_SmetaDb}.dbo.DEPARTMENTS D
WHERE
	ZB = 1
	AND
	NOT EXISTS (SELECT * FROM 
					{Variable_SmetaDb}.dbo.G_PROV G 
					INNER JOIN {Variable_SmetaDb}.dbo.S_OBJECTS so ON so.LINK = g.[OBJECT]
				WHERE 
					G.DEP = D.LINK 
					AND
					(
						G.[DATE] >= DATEADD(YEAR, DATEDIFF(YEAR, 0, GETDATE()), 0) --   
						OR
						so.CODE {WORK_COLLATE} = 'FINANS_CONTRACT'	--  
					)	
						
				)
	AND
	NOT EXISTS ( SELECT * FROM {Variable_SmetaDb}.dbo.ARestTableByDate(DATEADD(YEAR, DATEDIFF(YEAR, 0, GETDATE()), 0), DEFAULT) A
					WHERE A.DEP_LINK = 	D.LINK) 		
GO


USE {Variable_TempDb}
GO

IF exists(select * from sysobjects where id = object_id('[dbo].[__Journal]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
DROP TABLE dbo.[__Journal]
CREATE TABLE dbo.[__Journal] (ID INT IDENTITY(1,1), TITLE nvarchar(254), TEXT nvarchar(max), TABLE_NAME varchar(100), ROWS_NOT_COPIED bigint)

IF not exists(select * from sysobjects where id = object_id('[dbo].[__DEPARTMENTS_SMETA_KS]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__DEPARTMENTS_SMETA_KS] (
	[LINK_NEW] int ,
	[LINK_OLD] INT )
ELSE 
	DELETE FROM [dbo].[__DEPARTMENTS_SMETA_KS]
GO

--    -
--   ,   ,      
UPDATE D SET D.[TYPE] = 1
FROM
	{Variable_SmetaDb}.dbo.DEPARTMENT_ACCOUNTS DA
	INNER JOIN {Variable_SmetaDb}.dbo.DEPARTMENTS D ON DA.LINK_UP = D.LINK
WHERE
	D.[TYPE] = 3
	AND
	DA.[type] = 2
GO
	

IF  NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE [name] = 'IX__DEPARTMENTS_SMETA_KS')
CREATE INDEX [IX__DEPARTMENTS_SMETA_KS] ON [dbo].[__DEPARTMENTS_SMETA_KS] (LINK_OLD)-- ON [INDEX]
GO

set xact_abort on
BEGIN TRAN


IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'LINK_OLD' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].DEPARTMENTS'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].DEPARTMENTS DROP COLUMN [LINK_OLD]
	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].DEPARTMENTS ADD [LINK_OLD] INT NULL
GO

/*  */
INSERT INTO [{Variable_WorkDb}].dbo.DEPARTMENTS (
	CODE,
	[NAME],
	FULL_NAME,
	INN,
	KPP,
	OKPO,
	KLADR_LINK,
	HOUSE,
	FLAT,
	VED_LINK,
	MAIN_LINK,
	REGCODE,
	OKATO,
	FIN_CODE,
	TOFK_LINK,
	PFNUMBER,
	BUDG,
	BRON,
	PREFIX,
	PREFIX_POLUCH,
	OGRN,
	IMNS_LINK,
	ORD_HEAD,
	SBK_REGNUM,
	SBK_DOCNUM,
	SBK_DOCDATE,
	SBK_LINK,
	ZB,
	HIGH_LINK,
	PERS_LINK,
	INN_DOP,
	IS_RBS,
	FO_LINK,
	N_ACC_LINK,
	EGRUL,
	CODE_UBP,
	FSS_REG_NUM,
	FSS_KOD_P,
	FSS_KOD_DOP,
	OKOPF,
	OKFS,
	TFOMS_REG_NUM,
	TFOMS_KT,
	EMail,
	FSS_KP_P1,
	FSS_KP_P2,
	FSS_KP_P3,
	CORP,
	UCHR_LINK,
	CODE_TOFK,
	PHONE,
	[GUID],
	ROW_ID,
	[ACTION],
	[TYPE],
	[LINK_DEP],
	[LINK_OLD],
	IDENTITY_CARD,
	PERS_FNAME,
	PERS_NAME,
	PERS_SECNAME,
	POST_ADDR,
	REG_ADDR
) 
OUTPUT INSERTED.LINK, INSERTED.LINK_OLD
 	 INTO [{Variable_TempDb}].dbo.[__DEPARTMENTS_SMETA_KS] 
SELECT DISTINCT
	CODE          = LTRIM(RTRIM(d.CODE)), 
	[NAME]        = LTRIM(RTRIM(d.NAME)),
	FULL_NAME     = LEFT(LTRIM(RTRIM(d.FULL_NAME)),254),
	INN           = LEFT(d.INN,13), 
	KPP           = LEFT(d.KPP,9),
	OKPO          = LEFT(LTRIM(RTRIM(d.OKPO)),20),
	KLADR_LINK    = NULL,
	HOUSE         = LTRIM(RTRIM(d.HOUSE)),
	FLAT          = LTRIM(RTRIM(d.FLAT)),
	VED_LINK      = NULL,
	MAIN_LINK     = NULL,
	REGCODE       = d.REGCODE,
	OKATO         = d.OKATO,
	FIN_CODE      = d.FIN_CODE,
	TOFK_LINK     = NULL,
	PFNUMBER      = d.PFNUMBER,
	BUDG          = d.BUDG,
	BRON          = d.BRON,
	PREFIX        = d.PREFIX,
	PREFIX_POLUCH = d.PREFIX,
	OGRN          = LEFT(LTRIM(RTRIM(d.OGRN)),13),
	IMNS_LINK     = NULL,
	ORD_HEAD      = d.ORD_HEAD,
	SBK_REGNUM    = d.SBK_REGNUM,
	SBK_DOCNUM    = d.SBK_DOCNUM,
	SBK_DOCDATE   = d.SBK_DOCDATE,
	SBK_LINK      = NULL,
	ZB            = NULL,
	HIGH_LINK     = NULL,
	PERS_LINK     = NULL,
	INN_DOP       = d.INN_DOP,
	IS_RBS        = d.IS_RBS,
	FO_LINK       = NULL,
	N_ACC_LINK    = NULL,
	EGRUL         = LEFT(d.EGRUL,13),
	CODE_UBP      = LEFT(d.CODE_UBP,5),
	FSS_REG_NUM   = d.FSS_REG_NUM,
	FSS_KOD_P     = d.FSS_KOD_P,
	FSS_KOD_DOP   = d.FSS_KOD_DOP,
	OKOPF         = d.OKOPF,
	OKFS          = d.OKFS,
	TFOMS_REG_NUM = d.TFOMS_REG_NUM,
	TFOMS_KT      = d.TFOMS_KT,
	EMail         = d.EMail,
	FSS_KP_P1     = NULL,
	FSS_KP_P2     = NULL,
	FSS_KP_P3     = NULL,
	CORP          = d.CORP,
	UCHR_LINK     = NULL,
	CODE_TOFK     = RIGHT(d.CODE,4),
	PHONE         = '',
	[GUID]        = NULL,
	ROW_ID        = NULL,
	[ACTION]      = NULL,
	[TYPE]        = 0,
	LINK_DEP      = [{Variable_WorkDb}].dbo.getOwnDepLink(),
	[LINK_OLD]    = d.LINK,
	IDENTITY_CARD = NULL,
	PERS_FNAME    = '',
	PERS_NAME     = '',
	PERS_SECNAME  = '',
	--!!!
	POST_ADDR     = LEFT(ISNULL({Variable_SmetaDb}.dbo.GetAddressByKladr(D.KLADR_LINK), ''), 254),
	REG_ADDR      = LEFT(ISNULL({Variable_SmetaDb}.dbo.GetAddressByKladr(D.KLADR_LINK), ''), 254)
  FROM 
	{Variable_SmetaDb}.dbo.DEPARTMENTS d
  WHERE
  	(d.[TYPE]= 4 OR d.ZB = 1)
  

--    
DECLARE @iROWCOUNT INT
SET @iROWCOUNT = @@ROWCOUNT
INSERT INTO [{Variable_TempDb}].dbo.[__Journal]
VALUES (' " (-)"', ' : ' + convert(nvarchar(100),@iROWCOUNT), '', 0)
--

--      , , 
 INSERT INTO [{Variable_WorkDb}].dbo.DEPARTMENT_GROUPS_REF
 (DEP_LINK, GROUP_LINK)
 SELECT 
 DEP_LINK      = dsks.LINK_NEW,
 GROUP_LINK    = CASE WHEN d.BUH_TYPE = 0 OR d.BUH_TYPE = 2 THEN dg1.LINK
                 WHEN d.BUH_TYPE = 1 THEN dg2.LINK
                 WHEN d.BUH_TYPE = 4 THEN dg3.LINK END
 FROM [{Variable_TempDb}].dbo.[__DEPARTMENTS_SMETA_KS] dsks
 INNER JOIN {Variable_SmetaDb}.dbo.DEPARTMENTS d ON d.LINK = dsks.LINK_OLD
 LEFT JOIN [{Variable_WorkDb}].dbo.DEPARTMENT_GROUPS dg1 ON dg1.SNAME = ''
 LEFT JOIN [{Variable_WorkDb}].dbo.DEPARTMENT_GROUPS dg2 ON dg2.SNAME = ''
 LEFT JOIN [{Variable_WorkDb}].dbo.DEPARTMENT_GROUPS dg3 ON dg3.SNAME = ''
 WHERE NOT EXISTS (SELECT 1 FROM [{Variable_WorkDb}].dbo.DEPARTMENT_GROUPS_REF dgr WHERE dgr.DEP_LINK = dsks.LINK_NEW AND dgr.GROUP_LINK = 
            CASE WHEN d.BUH_TYPE = 0 OR d.BUH_TYPE = 2 THEN dg1.LINK
                 WHEN d.BUH_TYPE = 1 THEN dg2.LINK
                 WHEN d.BUH_TYPE = 4 THEN dg3.LINK END)

--       = 1
UPDATE D SET D.[SOURCE] = F.LINK
FROM
	{Variable_WorkDb}.dbo.DEPARTMENT_GROUPS G
	INNER JOIN {Variable_WorkDb}.dbo.DEPARTMENT_GROUPS_REF GR on GR.GROUP_LINK = G.LINK
	INNER JOIN {Variable_WorkDb}.dbo.DEPARTMENTS D ON D.LINK = GR.DEP_LINK
	INNER JOIN {Variable_WorkDb}.dbo.FIN_SOURCE F ON F.CODE = '1'
WHERE
	G.[SYS] = 3 AND G.SNAME = '' AND D.[SOURCE] IS NULL

--- 
DECLARE @LINK_OWN_OKVED INT
SET @LINK_OWN_OKVED = {Variable_WorkDb}.dbo.getOwnDepLink() 

--  
INSERT INTO {Variable_WorkDb}.[dbo].[OKVED] (CODE,NAME,LINK_DEP)
SELECT DISTINCT OKVED, OKVED, @LINK_OWN_OKVED FROM {Variable_SmetaDb}.dbo.DEPARTMENTS D
WHERE 
	ISNULL(OKVED,'') <> ''
	AND NOT EXISTS (SELECT * FROM {Variable_WorkDb}.[dbo].[OKVED] O WHERE O.CODE = D.OKVED AND O.LINK_DEP = @LINK_OWN_OKVED)
	
-- 
INSERT INTO {Variable_WorkDb}.dbo.DEPARTMENTS_OKVED([DEP],[OKVED],[MAIN])
SELECT dsks.LINK_NEW, O.LINK,1
FROM 
	{Variable_SmetaDb}.dbo.DEPARTMENTS d
	INNER JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_SMETA_KS] dsks ON dsks.LINK_OLD = d.LINK
	INNER JOIN {Variable_WorkDb}.[dbo].[OKVED] O ON O.LINK_DEP = @LINK_OWN_OKVED AND LTRIM(RTRIM(ISNULL(D.OKVED,''))) = LTRIM(RTRIM(O.CODE))
WHERE 
	ISNULL(D.OKVED,'') <> ''
	
--- 
DECLARE @LINK_OWN_DIC_OKTMO INT
SET @LINK_OWN_DIC_OKTMO = {Variable_WorkDb}.dbo.getOwnDepLink()

--  
INSERT INTO {Variable_WorkDb}.dbo.OKTMO (CODE, NAME, LINK_DEP)
SELECT DISTINCT OKTMO, OKTMO, @LINK_OWN_DIC_OKTMO FROM {Variable_SmetaDb}.dbo.DEPARTMENTS D
WHERE 
	ISNULL(OKTMO,'') <> ''
	AND NOT EXISTS (SELECT * FROM {Variable_WorkDb}.[dbo].[OKTMO] O WHERE O.CODE = D.OKTMO AND O.LINK_DEP = @LINK_OWN_OKVED)
-- 
UPDATE DO SET OKTMO = O.LINK
FROM
	{Variable_SmetaDb}.dbo.DEPARTMENTS d
	INNER JOIN {Variable_TempDb}.dbo.[__DEPARTMENTS_SMETA_KS] dsks ON dsks.LINK_OLD = d.LINK
	INNER JOIN {Variable_WorkDb}.dbo.OKTMO O ON O.LINK_DEP = @LINK_OWN_OKVED AND LTRIM(RTRIM(ISNULL(D.OKTMO,''))) = LTRIM(RTRIM(O.CODE))
	INNER JOIN {Variable_WorkDb}.dbo.DEPARTMENTS_OKATO DO ON DO.LINK_DEP = dsks.LINK_NEW
WHERE
	ISNULL(D.OKTMO,'') <> ''
	

-- LINK_DEP      
UPDATE {Variable_WorkDb}.dbo.DEPARTMENTS
SET LINK_DEP = {Variable_WorkDb}.dbo.getowndeplink()
WHERE LINK IN (select LINK_NEW from {Variable_TempDb}.dbo.[__DEPARTMENTS_SMETA_KS] )
--
 
EXECUTE {Variable_WorkDb}.dbo.UPD_DEPARTMENTS_ORDER

IF OBJECT_ID('tempdb..#DEPARTMENTS_LINK_DEP') IS NOT NULL
DROP TABLE #DEPARTMENTS_LINK_DEP
GO

--      
--   --
USE {Variable_WorkDb}
GO

DECLARE
	@LINK_TASK	INT,
	
	@BEGIN_YEAR	DATETIME,
	@END_YEAR	DATETIME

SET	@LINK_TASK = dbo.OBJ_ID ('SMETA')
SET	@BEGIN_YEAR	= DATEADD(YEAR, DATEDIFF(YEAR, 0, GETDATE()), 0)	--   
SET	@END_YEAR = DATEADD (DAY, -1, DATEADD(YEAR, 1, @BEGIN_YEAR))

INSERT INTO dbo.DEPARTMENTS_DATE
	(
	LINK_TASK,
	DEP_LINK,
	BEGINDATE,
	WORKDATE,
	ENDDATE,
	AUTO_PERIOD,
	AUTO_WORK,
	PERIOD_TYPE
	)

SELECT
	@LINK_TASK,
	DEP.LINK,
	@BEGIN_YEAR,
	@END_YEAR,
	@END_YEAR,
	0,
	0,
	2
FROM 
	dbo.DEPARTMENTS3 DEP
	INNER JOIN {Variable_TempDb}.dbo.[__DEPARTMENTS_SMETA_KS] T1 ON T1.LINK_NEW = DEP.LINK
WHERE 
	NOT EXISTS
			(
			SELECT 1
			FROM dbo.DEPARTMENTS_DATE TTT
			WHERE TTT.DEP_LINK = T1.LINK_NEW
				AND TTT.LINK_TASK = @LINK_TASK
			)

COMMIT TRAN


GO
