set xact_abort on
BEGIN TRAN

-- 
--   
USE {Variable_TempDb}
GO

IF not exists(select * from sysobjects where id = object_id('[dbo].[__DEPARTMENTS_]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__DEPARTMENTS_] (
	[LINK_NEW] INT,
	[LINK_OLD] INT )
ELSE 
	DELETE FROM [dbo].[__DEPARTMENTS_]
GO

IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'LINK_OLD' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].DEPARTMENTS'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].DEPARTMENTS DROP COLUMN [LINK_OLD]
	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].DEPARTMENTS ADD [LINK_OLD] INT NULL
GO

INSERT INTO [{Variable_WorkDb}].dbo.DEPARTMENTS WITH (ROWLOCK) (
 	-- LINK -- this column value is auto-generated
 	CODE,
 	[NAME],
 	FULL_NAME,
 	INN,
 	KPP,
 	OKPO,
 	KLADR_LINK,
 	HOUSE,
 	FLAT,
 	VED_LINK,
 	MAIN_LINK,
 	REGCODE,
 	OKATO,
 	FIN_CODE,
 	TOFK_LINK,
 	PFNUMBER,
 	BUDG,
 	BRON,
 	PREFIX,
 	OGRN,
 	IMNS_LINK,
 	ORD_HEAD,
 	SBK_REGNUM,
 	SBK_DOCNUM,
 	SBK_DOCDATE,
 	SBK_LINK,
 	ZB,
 	HIGH_LINK,
 	PERS_LINK,
 	INN_DOP,
 	IS_RBS,
 	FO_LINK,
 	N_ACC_LINK,
 	EGRUL,
 	CODE_UBP,
 	FSS_REG_NUM,
 	FSS_KOD_P,
 	FSS_KOD_DOP,
 	OKOPF,
 	OKFS,
 	TFOMS_REG_NUM,
 	TFOMS_KT,
 	EMail,
 	FSS_KP_P1,
 	FSS_KP_P2,
 	FSS_KP_P3,
 	CORP,
 	UCHR_LINK,
 	CODE_TOFK,
 	PHONE,
 	-- STAMP -- this column value is auto-generated
 	[GUID],
 	ROW_ID,
 	[ACTION],
 	[TYPE], 
 	[LINK_DEP],
 	[LINK_OLD]) 
OUTPUT 
	INSERTED.LINK, INSERTED.[LINK_OLD] INTO [{Variable_TempDb}].dbo.[__DEPARTMENTS_] ([LINK_NEW], [LINK_OLD])
SELECT 
	CODE          = ISNULL(LTRIM(RTRIM(b.[Code])),''),  
	[NAME]        = LEFT(LTRIM(RTRIM(b.[NAME])),254),
	FULL_NAME     = LEFT(LTRIM(RTRIM(b.[NAME])),254),
	INN           = '', 
 	KPP           = '',
 	OKPO          = '',
 	KLADR_LINK    = NULL,
 	HOUSE         = '',
 	FLAT          = '',
 	VED_LINK      = NULL,
 	MAIN_LINK     = NULL,
 	REGCODE       = '',
 	OKATO         = '',
 	FIN_CODE      = '',
 	TOFK_LINK     = NULL,
 	PFNUMBER      = '',
 	BUDG          = '',
 	BRON          = 0,
 	PREFIX        = '',
 	OGRN          = '',
 	IMNS_LINK     = NULL,
 	ORD_HEAD      = '',
 	SBK_REGNUM    = NULL,
 	SBK_DOCNUM    = '',
 	SBK_DOCDATE   = NULL,
 	SBK_LINK      = NULL,
 	ZB            = NULL,
 	HIGH_LINK     = NULL,
 	PERS_LINK     = NULL,
 	INN_DOP       = '',
 	IS_RBS        = 0,
 	FO_LINK       = NULL,
 	N_ACC_LINK    = NULL,
 	EGRUL         = '',
 	CODE_UBP      = '',
 	FSS_REG_NUM   = '',
 	FSS_KOD_P     = '',
 	FSS_KOD_DOP   = '',
 	OKOPF         = '',
 	OKFS          = '',
 	TFOMS_REG_NUM = '',
 	TFOMS_KT      = '',
 	EMail         = '',
 	FSS_KP_P1     = NULL,
 	FSS_KP_P2     = NULL,
 	FSS_KP_P3     = NULL,
 	CORP          = '',
 	UCHR_LINK     = NULL,
 	CODE_TOFK     = '',
 	PHONE         = '',
 	[GUID]        = NULL,
 	ROW_ID        = NULL,
 	[ACTION]      = NULL,
 	[TYPE]        = 0,
 	LINK_DEP      = {Variable_WorkDb}.dbo.getowndeplink(),
 	[LINK_OLD]   = b.LINK
  FROM 
	{Variable_SmetaDb}.dbo.KL_BUDG_TYPE b
  WHERE 
	NOT EXISTS (SELECT * FROM {Variable_WorkDb}.dbo.DEPARTMENTS_TYPE_FN(2) 
				WHERE LINK_DEP = {Variable_WorkDb}.dbo.getowndeplink() AND LTRIM(RTRIM(NAME)) = LTRIM(RTRIM(b.[NAME] {WORK_COLLATE})))

	--    
	DECLARE @iROWCOUNT BIGINT
	SET @iROWCOUNT = (SELECT COUNT(*) FROM {Variable_TempDb}.[dbo].[__DEPARTMENTS_])


IF exists(select 1 from {Variable_TempDb}.dbo.sysobjects where id = object_id('[dbo].[__JOURNAL_BUDG]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	DROP TABLE {Variable_TempDb}.dbo.[__JOURNAL_BUDG]

SELECT B.CODE, B.NAME, MSG = '       '
INTO
	{Variable_TempDb}.dbo.[__JOURNAL_BUDG] 
FROM 
	{Variable_SmetaDb}.dbo.KL_BUDG_TYPE B
	INNER JOIN {Variable_WorkDb}.dbo.DEPARTMENTS_TYPE_FN(2) T ON T.LINK_DEP = {Variable_WorkDb}.dbo.getowndeplink() AND LTRIM(RTRIM(T.NAME)) = LTRIM(RTRIM(b.[NAME] {WORK_COLLATE}))
WHERE 
	NOT EXISTS (SELECT * FROM {Variable_TempDb}.[dbo].[__DEPARTMENTS_] DB WHERE DB.LINK_OLD = b.LINK)

--      ,    
INSERT INTO {Variable_TempDb}.[dbo].[__DEPARTMENTS_] ([LINK_NEW],[LINK_OLD])
SELECT 
	T.LINK, B.LINK
FROM 
	{Variable_SmetaDb}.dbo.KL_BUDG_TYPE B
	INNER JOIN {Variable_WorkDb}.dbo.DEPARTMENTS_TYPE_FN(2) T ON T.LINK_DEP = {Variable_WorkDb}.dbo.getowndeplink() AND LTRIM(RTRIM(T.NAME)) = LTRIM(RTRIM(b.[NAME] {WORK_COLLATE}))
WHERE 
	NOT EXISTS (SELECT * FROM {Variable_TempDb}.[dbo].[__DEPARTMENTS_] DB WHERE DB.LINK_OLD = b.LINK)

--    
DECLARE @iROWCOUNT_NO BIGINT
SET @iROWCOUNT_NO = (SELECT COUNT(*) FROM {Variable_TempDb}.[dbo].[__DEPARTMENTS_])	- @iROWCOUNT

INSERT INTO [{Variable_TempDb}].dbo.[__Journal]
VALUES (' ""', ' : ' + convert(nvarchar(100),@iROWCOUNT), '__JOURNAL_BUDG', @iROWCOUNT_NO)

ALTER TABLE [{Variable_WorkDb}].[dbo].DEPARTMENTS DROP COLUMN [LINK_OLD]

---
DECLARE @iGROUP_LINK INT, @IERROR INT
SELECT @iGROUP_LINK = link FROM [{Variable_WorkDb}].dbo.DEPARTMENT_GROUPS dg
WHERE dg.SYS = 2

INSERT INTO [{Variable_WorkDb}].dbo.DEPARTMENT_GROUPS_REF WITH (ROWLOCK) (DEP_LINK, GROUP_LINK) 
SELECT sb.LINK_NEW, @iGROUP_LINK
FROM [{Variable_TempDb}].dbo.[__DEPARTMENTS_] sb
WHERE NOT EXISTS (SELECT * FROM [{Variable_WorkDb}].dbo.DEPARTMENT_GROUPS_REF T WHERE T.DEP_LINK = sb.LINK_NEW AND T.GROUP_LINK = @iGROUP_LINK)		
GO
--  
--   
USE {Variable_TempDb}
GO

IF not exists(select * from sysobjects where id = object_id('[dbo].[CODE_EL]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[CODE_EL]
(CODE_EL VARCHAR(10),REF UNIQUEIDENTIFIER)
GO

INSERT INTO [{Variable_TempDb}].dbo.CODE_EL (CODE_EL, REF)
SELECT LTRIM(RTRIM(ISNULL(T.CODE_EL,''))), NEWID()
FROM 
(
	SELECT DISTINCT 
		C.CODE_EL {WORK_COLLATE} AS CODE_EL
	FROM 
		{Variable_SmetaDb}.dbo.KL_BUDG_TYPE C
) T

USE {Variable_TempDb}
GO
IF not exists(select * from sysobjects where id = object_id('[dbo].[___]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[___] (
	[LINK_BUDG] int ,
	[CODE_EL] VARCHAR(10),
	[REF_EL] UNIQUEIDENTIFIER )
ELSE 
	DELETE FROM [dbo].[___]
GO

INSERT INTO [{Variable_TempDb}].dbo.[___] ([LINK_BUDG], [CODE_EL], [REF_EL]) 
SELECT DISTINCT A.LINK, B.CODE_EL, B.REF
FROM 
	{Variable_SmetaDb}.dbo.KL_BUDG_TYPE A
	INNER JOIN [{Variable_TempDb}].dbo.CODE_EL B ON LTRIM(RTRIM(ISNULL(A.CODE_EL {WORK_COLLATE},''))) = B.CODE_EL


IF not exists(select * from sysobjects where id = object_id('[dbo].[__KL_BUDG_TYPE_]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__KL_BUDG_TYPE_] (
	[LINK] int ,
	[Ref] UNIQUEIDENTIFIER )
ELSE 
	DELETE FROM [dbo].[__KL_BUDG_TYPE_]
GO

USE {Variable_WorkDb}
GO

IF COLUMNPROPERTY(object_id('{Variable_WorkDb}.[dbo].[BUDGET_TYPE]','U'), 'Ref', 'AllowsNull') is not NULL
	ALTER TABLE [dbo].[BUDGET_TYPE] DROP COLUMN [Ref]
GO
 --
 ALTER TABLE {Variable_WorkDb}.[dbo].BUDGET_TYPE ADD [Ref] UNIQUEIDENTIFIER
GO

USE {Variable_TempDb}
GO

INSERT INTO [{Variable_TempDb}].[dbo].[__KL_BUDG_TYPE_] ([LINK],[Ref])
SELECT DISTINCT
	T.LINK,
	A.REF_EL
FROM 
	[{Variable_TempDb}].dbo.[___] A
	INNER JOIN 
		(SELECT 
			LINK, 
			CODE_EL = LTRIM(RTRIM(ISNULL(T.CODE_EL,''))), 
			NUM = ROW_NUMBER() OVER (PARTITION BY LTRIM(RTRIM(ISNULL(T.CODE_EL,''))) ORDER BY T.LINK)
		FROM	  
			{Variable_WorkDb}.dbo.BUDGET_TYPE T
		WHERE 
			T.LINK_DEP = {Variable_WorkDb}.dbo.getowndeplink()	
		) T	 
			ON T.NUM = 1 AND LTRIM(RTRIM(ISNULL(T.CODE_EL,''))) = LTRIM(RTRIM(ISNULL(A.CODE_EL,'')))

--   ( )	
INSERT INTO {Variable_WorkDb}.dbo.BUDGET_TYPE(CODE,SNAME,NAME,LINK_DEP,CODE_EL,REF)
OUTPUT INSERTED.LINK, INSERTED.REF INTO [{Variable_TempDb}].[dbo].[__KL_BUDG_TYPE_] ([LINK],[Ref])
SELECT DISTINCT 
	CASE WHEN LTRIM(RTRIM(ISNULL(A.CODE_EL,''))) = '' THEN '-' ELSE A.CODE_EL END,
	CASE WHEN LTRIM(RTRIM(ISNULL(A.CODE_EL,''))) = '' THEN '-' ELSE A.CODE_EL END,
	CASE WHEN LTRIM(RTRIM(ISNULL(A.CODE_EL,''))) = '' THEN '-' ELSE A.CODE_EL END,
	{Variable_WorkDb}.dbo.getowndeplink(), 
	A.CODE_EL,
	A.REF_EL
FROM 
	[{Variable_TempDb}].dbo.[___] A
WHERE
	NOT EXISTS (SELECT * FROM [{Variable_TempDb}].[dbo].[__KL_BUDG_TYPE_] B WHERE B.REF = A.REF_EL)
						
--   
INSERT INTO {Variable_WorkDb}.dbo.BUDGET ([BUDG],[TYPE])
SELECT DISTINCT A.LINK_NEW, D.LINK
FROM 
	{Variable_TempDb}.dbo.[__DEPARTMENTS_] A
	INNER JOIN {Variable_SmetaDb}.dbo.KL_BUDG_TYPE B ON A.LINK_OLD = B.LINK
	INNER JOIN [{Variable_TempDb}].dbo.[___] C ON C.LINK_BUDG = B.LINK
	INNER JOIN [{Variable_TempDb}].[dbo].[__KL_BUDG_TYPE_] D ON D.REF = C.REF_EL
WHERE
	NOT EXISTS (SELECT * FROM {Variable_WorkDb}.dbo.BUDGET E WHERE E.BUDG = A.LINK_NEW)

--  
UPDATE E SET 
	E.BUDG_LINK = C.LINK_NEW
FROM
	(SELECT A.LINK_NEW, A.LINK_OLD, NUM = ROW_NUMBER() OVER (PARTITION BY A.LINK_NEW ORDER BY A.LINK_OLD DESC) FROM {Variable_TempDb}.[dbo].[__ADMIN_BS_SMETA_KS] A) A  
	INNER JOIN {Variable_SmetaDb}.dbo.KL_ADMIN_BS B ON B.LINK = A.LINK_OLD AND A.NUM = 1-- 
	INNER JOIN {Variable_TempDb}.dbo.[__DEPARTMENTS_] C ON C.LINK_OLD = B.LINK_BUDG
	INNER JOIN {Variable_WorkDb}.dbo.ADMIN_BS E ON E.LINK_UP = A.LINK_NEW

INSERT INTO {Variable_WorkDb}.dbo.ADMIN_BS (LINK_UP, BUDG_LINK)
SELECT A.LINK_NEW, C.LINK_NEW
FROM
	(SELECT A.LINK_NEW, A.LINK_OLD, NUM = ROW_NUMBER() OVER (PARTITION BY A.LINK_NEW ORDER BY A.LINK_OLD DESC) FROM {Variable_TempDb}.[dbo].[__ADMIN_BS_SMETA_KS] A) A 
	INNER JOIN {Variable_SmetaDb}.dbo.KL_ADMIN_BS B ON B.LINK = A.LINK_OLD AND A.NUM = 1-- 
	INNER JOIN {Variable_TempDb}.dbo.[__DEPARTMENTS_] C ON C.LINK_OLD = B.LINK_BUDG
WHERE
	NOT EXISTS (SELECT * FROM {Variable_WorkDb}.dbo.ADMIN_BS E WHERE E.LINK_UP = A.LINK_NEW)	

--         
UPDATE C SET 
	C.[SUB_DEP] = D.LINK_NEW,
	C.LINK_BUDG = E.BUDG_LINK
--SELECT C.[SUB_DEP], D.LINK_NEW, C.LINK_BUDG, E.BUDG_LINK
FROM 
	{Variable_TempDb}.dbo.[__DEPARTMENTS_SMETA_KS] A
	INNER JOIN {Variable_SmetaDb}.dbo.DEPARTMENTS B ON B.LINK = A.LINK_OLD
	INNER JOIN {Variable_WorkDb}.dbo.DEPARTMENTS C ON C.LINK = A.LINK_NEW
	INNER JOIN {Variable_TempDb}.[dbo].[__ADMIN_BS_SMETA_KS] D ON D.LINK_OLD = B.VED_LINK
	LEFT JOIN {Variable_WorkDb}.dbo.ADMIN_BS E ON E.LINK_UP = D.LINK_NEW --

GO

COMMIT TRAN
