 
--   
USE {Variable_TempDb}
GO

set xact_abort on
BEGIN TRAN

IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'LINK_OLD' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].DEPARTMENTS'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].DEPARTMENTS DROP COLUMN [LINK_OLD]
	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].DEPARTMENTS ADD [LINK_OLD] INT NULL
GO

DECLARE @dDATE DATETIME
SET @dDATE = DATEADD(YEAR, DATEDIFF(YEAR, 0, GETDATE()), 0) --   

---     LINK_DEP 
select distinct GAP.DEP AS DEPARTMENT, G.DEP AS LINK_DEP
INTO #DEPARTMENTS_LINK_DEP
from 
	{Variable_SmetaDb}.dbo.G_PROV G
	inner join {Variable_SmetaDb}.dbo.G_PROV1 G1 on G1.LINK_UP = G.LINK
	inner join {Variable_SmetaDb}.dbo.G_PROV2 G2 on G2.LINK_UP = G1.LINK
	inner join {Variable_SmetaDb}.dbo.G_PROV_AP GAP on GAP.LINK_UP = G2.LINK
where
	G.DATE >= @dDATE
	AND 
	GAP.DEP is NOT NULL
GROUP BY
	GAP.DEP, G.DEP	
UNION
SELECT
	A.DEP AS DEPARTMENT, A.DEP_LINK AS LINK_DEP
FROM
	{Variable_SmetaDb}.dbo.ARestTableByDate(@dDATE, DEFAULT) A	
WHERE
	A.DEP IS NOT NULL
GROUP BY
	DEP, DEP_LINK	
	
------------------------------------------------------

--    
INSERT INTO [{Variable_TempDb}].dbo.[__DEPARTMENTS_SMETA_KS] ([LINK_NEW], [LINK_OLD])
SELECT DISTINCT D.LINK, B.[LINK]
FROM 
	{Variable_SmetaDb}.dbo.DEPARTMENTS b
	INNER JOIN 
	(
		SELECT [LINK], [TYPE], INN, FULL_NAME, NUM = ROW_NUMBER() OVER (PARTITION BY [TYPE], INN, FULL_NAME ORDER BY [LINK])	
		FROM [{Variable_WorkDb}].dbo.DEPARTMENTS
	) D	ON D.NUM = 1 
		AND
		D.[TYPE] = B.[TYPE] AND D.[TYPE] = 2
		AND
		D.INN = LEFT(ISNULL(LTRIM(RTRIM( B.INN)),''),13)
		AND
		D.FULL_NAME = LEFT(B.FULL_NAME,254)		 
WHERE
	NOT EXISTS (SELECT * FROM [{Variable_TempDb}].dbo.[__DEPARTMENTS_SMETA_KS] T WHERE T.[LINK_OLD] = B.[LINK])		
	AND LEN(LEFT(ISNULL(LTRIM(RTRIM( B.INN)),''),13)) >= 10
	AND LEN(LEFT(B.FULL_NAME,254)) > 0
	AND LEN(LEFT(D.FULL_NAME,254)) > 0
--GROUP BY 
--	B.[LINK]
--HAVING
--	COUNT(*) > 1

--  
--    
INSERT INTO [{Variable_TempDb}].dbo.[__DEPARTMENTS_SMETA_KS] ([LINK_NEW], [LINK_OLD])
SELECT DISTINCT D.LINK, B.[LINK]
FROM 
	{Variable_SmetaDb}.dbo.DEPARTMENTS b
	INNER JOIN 
	(
		SELECT [LINK], [TYPE], INN, KPP, NUM = ROW_NUMBER() OVER (PARTITION BY [TYPE], INN, KPP ORDER BY [LINK])
		FROM [{Variable_WorkDb}].dbo.DEPARTMENTS
	) D	ON D.NUM = 1 
		AND
		D.[TYPE] = B.[TYPE] AND D.[TYPE] = 2
		AND
		D.INN = LEFT(ISNULL(LTRIM(RTRIM( B.INN)),''),13)
		AND
		D.KPP = LEFT(ISNULL(LTRIM(RTRIM( B.KPP)),''),9)		 
WHERE
	NOT EXISTS (SELECT * FROM [{Variable_TempDb}].dbo.[__DEPARTMENTS_SMETA_KS] T WHERE T.[LINK_OLD] = B.[LINK])		
	AND LEN(LEFT(ISNULL(LTRIM(RTRIM( B.INN)),''),13)) >= 10
	AND LEN(LEFT(ISNULL(LTRIM(RTRIM( B.KPP)),''),9)) = 9
	AND LEN(LEFT(ISNULL(LTRIM(RTRIM( D.INN)),''),13)) >= 10
	AND LEN(LEFT(ISNULL(LTRIM(RTRIM( D.KPP)),''),9)) = 9
--GROUP BY 
--	B.[LINK]
--HAVING
--	COUNT(*) > 1


--  
--    
INSERT INTO [{Variable_TempDb}].dbo.[__DEPARTMENTS_SMETA_KS] ([LINK_NEW], [LINK_OLD])
SELECT DISTINCT D.LINK, B.[LINK]
FROM 
	{Variable_SmetaDb}.dbo.DEPARTMENTS b
    INNER JOIN {Variable_SmetaDb}.dbo.PERSON p ON p.LINK = b.PERS_LINK	
	INNER JOIN 
	(
		SELECT [LINK], [TYPE], INN, PERS_FNAME, PERS_NAME, PERS_SECNAME, NUM = ROW_NUMBER() OVER (PARTITION BY [TYPE], INN, PERS_FNAME, PERS_NAME, PERS_SECNAME ORDER BY [LINK])	
		FROM [{Variable_WorkDb}].dbo.DEPARTMENTS
	) D	ON D.NUM = 1 
		AND
		D.[TYPE] = B.[TYPE] AND D.[TYPE] = 2
		AND
		D.INN = LEFT(ISNULL(LTRIM(RTRIM( B.INN)),''),13)
		AND
		LTRIM(RTRIM(D.PERS_FNAME)) = LTRIM(RTRIM(p.FM))
			AND
			LTRIM(RTRIM(D.PERS_NAME)) = LTRIM(RTRIM(p.IM))
			AND
			LTRIM(RTRIM(D.PERS_SECNAME)) = LTRIM(RTRIM(ISNULL(p.OT,'')))
WHERE
	NOT EXISTS (SELECT * FROM [{Variable_TempDb}].dbo.[__DEPARTMENTS_SMETA_KS] T WHERE T.[LINK_OLD] = B.[LINK])		
	AND LEN(LEFT(ISNULL(LTRIM(RTRIM( B.INN)),''),13)) >= 10
	AND LEN(LEFT(ISNULL(LTRIM(RTRIM( B.INN)),''),13)) >= 10
	AND LEN(ISNULL(LTRIM(RTRIM(p.FM)),'')) >= 1
	AND LEN(ISNULL(LTRIM(RTRIM(p.IM)),'')) >= 1
	AND LEN(ISNULL(LTRIM(RTRIM(D.PERS_FNAME)),'')) >= 1
	AND LEN(ISNULL(LTRIM(RTRIM(D.PERS_NAME)),'')) >= 1
--GROUP BY 
--	B.[LINK]
--HAVING
--	COUNT(*) > 1


----  
--INSERT INTO [{Variable_TempDb}].dbo.[__DEPARTMENTS_SMETA_KS] ([LINK_NEW], [LINK_OLD])
--SELECT DISTINCT D.LINK, B.[LINK]
--FROM 
--	{Variable_SmetaDb}.dbo.DEPARTMENTS b
--	INNER JOIN 
--	(
--		SELECT [LINK], [TYPE], INN, NUM = ROW_NUMBER() OVER (PARTITION BY [TYPE], INN ORDER BY [LINK])	
--		FROM [{Variable_WorkDb}].dbo.DEPARTMENTS
--		WHERE LINK_DEP = [{Variable_WorkDb}].dbo.GetSaveDictDepLink('DEPARTMENTS_CORR_G', {LINK_DEP_MAIN}) /*  */
--	) D	ON D.NUM = 1 
--		AND
--		D.[TYPE] = B.[TYPE] AND D.[TYPE] = 2
--		AND
--		D.INN = LEFT(ISNULL(LTRIM(RTRIM( B.INN)),''),13)
--WHERE
--	NOT EXISTS (SELECT * FROM [{Variable_TempDb}].dbo.[__DEPARTMENTS_SMETA_KS] T WHERE T.[LINK_OLD] = B.[LINK])		
--	AND LEN(LEFT(ISNULL(LTRIM(RTRIM( B.INN)),''),13)) >= 10
----GROUP BY 
----	B.[LINK]
----HAVING
----	COUNT(*) > 1


--  
INSERT INTO [{Variable_TempDb}].dbo.[__DEPARTMENTS_SMETA_KS] ([LINK_NEW], [LINK_OLD])
SELECT DISTINCT D.LINK, B.[LINK]
FROM 
	{Variable_SmetaDb}.dbo.DEPARTMENTS b
	INNER JOIN 
	(
		SELECT [LINK], [TYPE], FULL_NAME, NUM = ROW_NUMBER() OVER (PARTITION BY [TYPE], FULL_NAME ORDER BY [LINK])	
		FROM [{Variable_WorkDb}].dbo.DEPARTMENTS
	) D	ON D.NUM = 1 
		AND
		D.[TYPE] = B.[TYPE] AND D.[TYPE] = 2
		AND
		D.FULL_NAME = LEFT(B.FULL_NAME,254)		 
WHERE
	NOT EXISTS (SELECT * FROM [{Variable_TempDb}].dbo.[__DEPARTMENTS_SMETA_KS] T WHERE T.[LINK_OLD] = B.[LINK])		
	AND LEN(LEFT(B.FULL_NAME,254)) > 0
	AND LEN(LEFT(D.FULL_NAME,254)) > 0
--GROUP BY 
--	B.[LINK]
--HAVING
--	COUNT(*) > 1

----  
----  
--INSERT INTO [{Variable_TempDb}].dbo.[__DEPARTMENTS_SMETA_KS] ([LINK_NEW], [LINK_OLD])
--SELECT DISTINCT D.LINK, B.[LINK]
--FROM 
--	{Variable_SmetaDb}.dbo.DEPARTMENTS b
--    INNER JOIN {Variable_SmetaDb}.dbo.PERSON p ON p.LINK = b.PERS_LINK	
--	INNER JOIN 
--	(
--		SELECT [LINK], [TYPE], PERS_FNAME, PERS_NAME, PERS_SECNAME, NUM = ROW_NUMBER() OVER (PARTITION BY [TYPE], PERS_FNAME, PERS_NAME, PERS_SECNAME ORDER BY [LINK])	
--		FROM [{Variable_WorkDb}].dbo.DEPARTMENTS
--		WHERE LINK_DEP = [{Variable_WorkDb}].dbo.GetSaveDictDepLink('DEPARTMENTS_CORR_G', {LINK_DEP_MAIN}) /*  */
--	) D	ON D.NUM = 1 
--		AND
--		D.[TYPE] = B.[TYPE] AND D.[TYPE] = 2
--		AND
--		LTRIM(RTRIM(D.PERS_FNAME)) = LTRIM(RTRIM(p.FM))
--			AND
--			LTRIM(RTRIM(D.PERS_NAME)) = LTRIM(RTRIM(p.IM))
--			AND
--			LTRIM(RTRIM(D.PERS_SECNAME)) = LTRIM(RTRIM(ISNULL(p.OT,'')))
--WHERE
--	NOT EXISTS (SELECT * FROM [{Variable_TempDb}].dbo.[__DEPARTMENTS_SMETA_KS] T WHERE T.[LINK_OLD] = B.[LINK])		
--	AND LEN(LEFT(ISNULL(LTRIM(RTRIM( B.INN)),''),13)) <= 10
--	AND LEN(ISNULL(LTRIM(RTRIM(p.FM)),'')) >= 1
--	AND LEN(ISNULL(LTRIM(RTRIM(p.IM)),'')) >= 1
----GROUP BY 
----	B.[LINK]
----HAVING
----	COUNT(*) > 1

--    
INSERT INTO [{Variable_WorkDb}].dbo.DEPARTMENTS (
	-- LINK -- this column value is auto-generated
	CODE,
	[NAME],
	FULL_NAME,
	INN,
	KPP,
	OKPO,
	KLADR_LINK,
	HOUSE,
	FLAT,
	VED_LINK,
	MAIN_LINK,
	REGCODE,
	OKATO,
	FIN_CODE,
	TOFK_LINK,
	PFNUMBER,
	BUDG,
	BRON,
	PREFIX_POLUCH,
	OGRN,
	IMNS_LINK,
	ORD_HEAD,
	SBK_REGNUM,
	SBK_DOCNUM,
	SBK_DOCDATE,
	SBK_LINK,
	ZB,
	HIGH_LINK,
	PERS_LINK,
	INN_DOP,
	IS_RBS,
	FO_LINK,
	N_ACC_LINK,
	EGRUL,
	CODE_UBP,
	FSS_REG_NUM,
	FSS_KOD_P,
	FSS_KOD_DOP,
	OKOPF,
	OKFS,
	TFOMS_REG_NUM,
	TFOMS_KT,
	EMail,
	FSS_KP_P1,
	FSS_KP_P2,
	FSS_KP_P3,
	CORP,
	UCHR_LINK,
	CODE_TOFK,
	PHONE,
	-- STAMP -- this column value is auto-generated
	[GUID],
	ROW_ID,
	[ACTION],
	[TYPE],
	[LINK_DEP],
	[LINK_OLD],
	IDENTITY_CARD,
	PERS_FNAME,
	PERS_NAME,
	PERS_SECNAME,
	POST_ADDR,
	REG_ADDR
	) 
OUTPUT INSERTED.LINK, INSERTED.LINK_OLD
 	 INTO [{Variable_TempDb}].dbo.[__DEPARTMENTS_SMETA_KS] 
SELECT DISTINCT
	CODE          = LEFT(LTRIM(RTRIM(d.CODE)),20),
	[NAME]        = LEFT(LTRIM(RTRIM(d.NAME)),254),
	FULL_NAME     = LEFT(LTRIM(RTRIM(d.FULL_NAME)),254),
	INN           = LEFT(d.INN,13), 
 	KPP           = LEFT(d.KPP,9),
 	OKPO          = LEFT(LTRIM(RTRIM(d.OKPO)),20),
 	KLADR_LINK    = NULL,
 	HOUSE         = LEFT(d.HOUSE,8),
 	FLAT          = LEFT(d.FLAT,4),
 	VED_LINK      = NULL,
 	MAIN_LINK     = NULL,
 	REGCODE       = LEFT(d.REGCODE,200),
 	OKATO         = LEFT(d.OKATO,14),
 	FIN_CODE      = LEFT(d.FIN_CODE,1),
 	TOFK_LINK     = NULL,
 	PFNUMBER      = LEFT(d.PFNUMBER,15),
 	BUDG          = LEFT(d.BUDG,10),
 	BRON          = d.BRON,
 	PREFIX_POLUCH        = LEFT(d.PREFIX,254),
 	OGRN          = LEFT(d.OGRN,13),
 	IMNS_LINK     = NULL,
 	ORD_HEAD      = LEFT(d.ORD_HEAD,5000),
 	SBK_REGNUM    = LEFT(d.SBK_REGNUM,20),
 	SBK_DOCNUM    = LEFT(d.SBK_DOCNUM,20),
 	SBK_DOCDATE   = d.SBK_DOCDATE,
 	SBK_LINK      = NULL,
 	ZB            = NULL,
 	HIGH_LINK     = NULL,
 	PERS_LINK     = NULL,
 	INN_DOP       = LEFT(d.INN_DOP,2),
 	IS_RBS        = d.IS_RBS,
 	FO_LINK       = NULL,
 	N_ACC_LINK    = NULL,
 	EGRUL         = LEFT(d.EGRUL,13),
 	CODE_UBP      = LEFT(d.CODE_UBP,5),
 	FSS_REG_NUM   = LEFT(d.FSS_REG_NUM,10),
 	FSS_KOD_P     = LEFT(d.FSS_KOD_P,5),
 	FSS_KOD_DOP   = LEFT(d.FSS_KOD_DOP,10),
 	OKOPF         = LEFT(d.OKOPF,2),
 	OKFS          = LEFT(d.OKFS,2),
 	TFOMS_REG_NUM = LEFT(d.TFOMS_REG_NUM,15),
 	TFOMS_KT      = LEFT(d.TFOMS_KT,2),
 	EMail         = LEFT(d.EMail,254),
 	FSS_KP_P1     = NULL,
 	FSS_KP_P2     = NULL,
 	FSS_KP_P3     = NULL,
 	CORP          = d.CORP,
 	UCHR_LINK     = NULL,
 	CODE_TOFK     = RIGHT(d.CODE,4),
 	PHONE         = '',
 	[GUID]        = NULL,
 	ROW_ID        = NULL,
 	[ACTION]      = NULL,
 	[TYPE]        = CASE WHEN d.[TYPE] = 3 THEN 1 ELSE 0 END,
 	LINK_DEP      = [{Variable_WorkDb}].dbo.getOwnDepLink(),
 	[LINK_OLD]    = d.LINK,
 	IDENTITY_CARD = LEFT(',' + isnull(RTRIM(p.DOC_NUM),'')+ ',' + isnull(convert(varchar(200),p.DOC_DATE,104),'') + ',' + isnull(LTRIM(RTRIM(p.DOC_WHOM)),''),1000),
	  PERS_FNAME    = LEFT(p.FM,100),
	  PERS_NAME     = LEFT(p.IM,100),
	  PERS_SECNAME  = LEFT(p.OT,100),  
	  --!!!
	  POST_ADDR     = LEFT(ISNULL({Variable_SmetaDb}.dbo.GetAddressByKladr(D.KLADR_LINK), ''), 254),
	  REG_ADDR      = LEFT(ISNULL({Variable_SmetaDb}.dbo.GetAddressByKladr(D.KLADR_LINK), ''), 254)
FROM 
	{Variable_SmetaDb}.dbo.DEPARTMENTS d
	LEFT JOIN {Variable_SmetaDb}.dbo.PERSON p ON p.LINK = d.PERS_LINK
WHERE 
	NOT EXISTS (SELECT * FROM [{Variable_TempDb}].dbo.[__DEPARTMENTS_SMETA_KS] T WHERE T.[LINK_OLD] = D.LINK)
	AND (not (d.type = 4 or d.zb = 1)  --    
    OR ((d.type = 4 or d.zb = 1) AND d.LINK NOT IN (SELECT DISTINCT DEP FROM {Variable_SmetaDb}.dbo.G_PROV) )) --   ,      
    --AND 
    --EXISTS (SELECT * FROM #DEPARTMENTS_LINK_DEP K WHERE K.DEPARTMENT = D.LINK)

--    
DECLARE @iROWCOUNT1 INT
SET @iROWCOUNT1 = @@ROWCOUNT
INSERT INTO [{Variable_TempDb}].dbo.[__Journal]
VALUES (' " (-)"', ' : ' + convert(nvarchar(100),@iROWCOUNT1), '', 0)

---   
UPDATE [{Variable_WorkDb}].dbo.DEPARTMENTS
SET IDENTITY_CARD = NULL
WHERE LTRIM(RTRIM(IDENTITY_CARD {WORK_COLLATE})) = ''
 
-- 
DECLARE @iGROUP_LINK INT
 ---     
DECLARE @iERROR INT
SELECT @iGROUP_LINK = link FROM [{Variable_WorkDb}].dbo.DEPARTMENT_GROUPS dg
WHERE dg.SYS = 4
    
INSERT INTO [{Variable_WorkDb}].dbo.DEPARTMENT_GROUPS_REF WITH (ROWLOCK) (DEP_LINK, GROUP_LINK) 
SELECT DISTINCT
	sb.link_NEW, @iGROUP_LINK
FROM 
	[{Variable_TempDb}].dbo.[__DEPARTMENTS_SMETA_KS] sb
	INNER JOIN {Variable_SmetaDb}.dbo.DEPARTMENTS d ON d.LINK = sb.LINK_OLD
WHERE 
	(not (d.type = 4 or d.zb = 1) OR ((d.type = 4 or d.zb = 1) AND d.LINK NOT IN (SELECT DISTINCT DEP FROM {Variable_SmetaDb}.dbo.G_PROV) ))
	AND NOT EXISTS (SELECT * FROM [{Variable_WorkDb}].dbo.DEPARTMENT_GROUPS_REF R WHERE R.DEP_LINK = sb.link_NEW AND R.GROUP_LINK = @iGROUP_LINK)
 
 ---     
SELECT @iGROUP_LINK = link FROM [{Variable_WorkDb}].dbo.DEPARTMENT_GROUPS dg
WHERE dg.SYS = 5
    
INSERT INTO [{Variable_WorkDb}].dbo.DEPARTMENT_GROUPS_REF WITH (ROWLOCK) (DEP_LINK, GROUP_LINK) 
SELECT DISTINCT
	sb.link_NEW, @iGROUP_LINK
FROM 
	[{Variable_TempDb}].dbo.[__DEPARTMENTS_SMETA_KS] sb
	INNER JOIN {Variable_SmetaDb}.dbo.DEPARTMENTS d ON d.LINK = sb.LINK_OLD
WHERE 
	d.[type] = 1
	AND NOT EXISTS (SELECT * FROM [{Variable_WorkDb}].dbo.DEPARTMENT_GROUPS_REF R WHERE R.DEP_LINK = sb.link_NEW AND R.GROUP_LINK = @iGROUP_LINK)
GO



--- 
-- 
UPDATE D_NEW SET D_NEW.OKTMO = O.LINK
FROM
	[{Variable_WorkDb}].dbo.DEPARTMENTS D_NEW
	INNER JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_SMETA_KS] dsks ON dsks.LINK_NEW = D_NEW.LINK
	INNER JOIN {Variable_SmetaDb}.dbo.DEPARTMENTS d ON dsks.LINK_OLD = d.LINK
	INNER JOIN [{Variable_WorkDb}].dbo.OKTMO O ON O.LINK_DEP = {Variable_WorkDb}.dbo.getOwnDepLink() AND LTRIM(RTRIM(ISNULL(D.OKTMO,''))) = LTRIM(RTRIM(O.CODE))
WHERE
	ISNULL(D.OKTMO,'') <> ''
GO


-----------------------------------------------------------------------------
		

ALTER TABLE [{Variable_WorkDb}].[dbo].DEPARTMENTS DROP COLUMN [LINK_OLD]
GO
		
EXECUTE [{Variable_WorkDb}].dbo.UPD_DEPARTMENTS_ORDER
GO

--    
EXEC [{Variable_WorkDb}].dbo.gen_corr_groups_str
GO

IF OBJECT_ID('tempdb..#DEPARTMENTS_LINK_DEP') IS NOT NULL
DROP TABLE #DEPARTMENTS_LINK_DEP

COMMIT TRAN

--   
GO
