
set xact_abort ON

BEGIN TRAN 

USE [{Variable_WorkDb}]

IF exists(select * from sysobjects where id = object_id('[dbo].[conv_DEPARTMENTS_DATE]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	DROP TABLE [dbo].[conv_DEPARTMENTS_DATE]
GO

CREATE TABLE [dbo].[conv_DEPARTMENTS_DATE] (
	[LINK_TASK] int,
	[DEP_LINK] int,
	[BEGINDATE] datetime,
	[WORKDATE] datetime,
	[ENDDATE] datetime)
GO

INSERT INTO [{Variable_WorkDb}].[dbo].[conv_DEPARTMENTS_DATE]([LINK_TASK], [DEP_LINK], [BEGINDATE], [WORKDATE], [ENDDATE])
SELECT B.[LINK_TASK], B.[DEP_LINK], B.[BEGINDATE], B.[WORKDATE], B.[ENDDATE]
FROM 
	[{Variable_TempDb}].dbo.__DEPARTMENTS_SMETA_KS A
	INNER JOIN [{Variable_WorkDb}].dbo.DEPARTMENTS_DATE B ON B.DEP_LINK = A.LINK_NEW
GO

/*    ,    */
UPDATE B SET 
	BEGINDATE = '20000101',
	WORKDATE = DATEADD(DAY,-1,GETDATE()),
	ENDDATE = '20490101'
FROM
	[{Variable_WorkDb}].dbo.DEPARTMENTS_DATE B
	INNER JOIN [{Variable_WorkDb}].[dbo].[conv_DEPARTMENTS_DATE] A ON B.[DEP_LINK] = A.[DEP_LINK] AND A.[LINK_TASK] = B.[LINK_TASK]	
GO

USE {Variable_TempDb}
GO
-- 
--   
IF not exists(select * from sysobjects where id = object_id('[dbo].[__G_PROV_SMETA_KS]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__G_PROV_SMETA_KS] (
	[LINK_NEW] int ,
	[LINK_OLD] int)
ELSE 
	DELETE FROM [dbo].[__G_PROV_SMETA_KS]
	GO

IF  NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE [name] = 'IX__G_PROV_SMETA_KS')
CREATE INDEX [IX__G_PROV_SMETA_KS] ON [dbo].[__G_PROV_SMETA_KS] (LINK_OLD)-- ON [INDEX]
GO
	
IF not exists(select * from sysobjects where id = object_id('[dbo].[__G_PROV1_SMETA_KS]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__G_PROV1_SMETA_KS] (
	[LINK_NEW] int ,
	[LINK_OLD] int)
ELSE 
	DELETE FROM [dbo].[__G_PROV1_SMETA_KS]
	GO

IF  NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE [name] = 'IX__G_PROV1_SMETA_KS')
CREATE INDEX [IX__G_PROV1_SMETA_KS] ON [dbo].[__G_PROV1_SMETA_KS] (LINK_OLD)-- ON [INDEX]
GO
	
	
IF not exists(select * from sysobjects where id = object_id('[dbo].[__G_PROV2_SMETA_KS]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__G_PROV2_SMETA_KS] (
	[LINK_NEW] int ,
	[LINK_OLD] int,
	[ACC_DT] INT,
	[ACC_KT] INT,
	[DEP] INT)
	
ELSE 
	DELETE FROM [dbo].[__G_PROV2_SMETA_KS]
	GO

IF  NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE [name] = 'IX__G_PROV2_SMETA_KS')
CREATE INDEX [IX__G_PROV2_SMETA_KS] ON [dbo].[__G_PROV2_SMETA_KS] (LINK_OLD)-- ON [INDEX]
GO

IF not exists(select * from sysobjects where id = object_id('[dbo].[__VIBOR_ECON_OPER]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__VIBOR_ECON_OPER] (
	[ACC_DT] INT,
	[ACC_KT] INT,
	[DEP] INT,
	[ECON_OPER] INT)
	
ELSE 
	DELETE FROM [dbo].[__VIBOR_ECON_OPER]
	GO
	
IF  NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE [name] = 'IX__VIBOR_ECON_OPER1')
CREATE INDEX [IX__VIBOR_ECON_OPER1] ON [dbo].[__VIBOR_ECON_OPER] (ACC_DT)-- ON [INDEX]
GO
IF  NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE [name] = 'IX__VIBOR_ECON_OPER2')
CREATE INDEX [IX__VIBOR_ECON_OPER2] ON [dbo].[__VIBOR_ECON_OPER] (ACC_KT)-- ON [INDEX]
GO
IF  NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE [name] = 'IX__VIBOR_ECON_OPER3')
CREATE INDEX [IX__VIBOR_ECON_OPER3] ON [dbo].[__VIBOR_ECON_OPER] (DEP)-- ON [INDEX]
GO
IF  NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE [name] = 'IX__VIBOR_ECON_OPER4')
CREATE INDEX [IX__VIBOR_ECON_OPER4] ON [dbo].[__VIBOR_ECON_OPER] (ECON_OPER)-- ON [INDEX]
GO

IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'LINK_OLD' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].G_PROV'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV DROP COLUMN [LINK_OLD]
	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV ADD [LINK_OLD] INT NULL
GO
	
IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'LINK_OLD' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].G_PROV1'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV1 DROP COLUMN [LINK_OLD]
	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV1 ADD [LINK_OLD] INT NULL
GO

IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'LINK_OLD' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].G_PROV2'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV2 DROP COLUMN [LINK_OLD]
	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV2 ADD [LINK_OLD] INT NULL
GO

IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'ACC_DT' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].G_PROV2'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV2 DROP COLUMN [ACC_DT]
	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV2 ADD [ACC_DT] INT NULL
GO

IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'ACC_KT' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].G_PROV2'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV2 DROP COLUMN [ACC_KT]
	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV2 ADD [ACC_KT] INT NULL
GO

IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'DEP' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].G_PROV2'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV2 DROP COLUMN [DEP]
	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV2 ADD [DEP] INT NULL
GO

DECLARE @iOBJECT INT
SELECT @iOBJECT = LINK FROM [{Variable_WorkDb}].dbo.S_OBJECTS so WHERE so.CODE = 'DOCUMENTS_OPER'

DECLARE @dDATE DATETIME
SET @dDATE = DATEADD(YEAR, DATEDIFF(YEAR, 0, GETDATE()), 0) --   

INSERT INTO [{Variable_WorkDb}].dbo.G_PROV
(NUMBER, DATE, [OBJECT], DATE_PROV, SUMMA, COMMENT, GET_STORE, DEP, ACC, LINK_OLD)
    OUTPUT INSERTED.LINK,INSERTED.LINK_OLD
		 INTO [{Variable_TempDb}].dbo.[__G_PROV_SMETA_KS]
SELECT DISTINCT
 NUMBER     = LTRIM(RTRIM(g.NUMBER))
,DATE       = g.DATE
,[OBJECT]   = @iOBJECT
,DATE_PROV  = g.DATE_PROV
,SUMMA      = g.SUMMA
,COMMENT    = g.COMMENT
,GET_STORE  = 0
,DEP        = ISNULL(d.LINK,{LINK_DEP_MAIN})
,ACC        = D.MAIN_LINK
,LINK_OLD   = g.LINK
FROM 
	{Variable_SmetaDb}.dbo.G_PROV g
	INNER JOIN {Variable_SmetaDb}.dbo.G_PROV1 g1 ON g1.LINK_UP = g.LINK
	LEFT JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_SMETA_KS] dsks ON dsks.LINK_OLD = G.DEP
	LEFT JOIN [{Variable_WorkDb}].dbo.DEPARTMENTS d ON d.LINK = dsks.LINK_NEW
WHERE 
(
	g.DATE_PROV >= @dDATE
	OR
	g.DATE_PROV IS NULL AND G.DATE >= @dDATE
)


INSERT INTO [{Variable_WorkDb}].dbo.G_PROV1
(LINK_UP, OPER, NAME_OPER, ORDERS, LINK_DEP, [LINK_OLD])
   OUTPUT INSERTED.LINK,INSERTED.LINK_OLD
		 INTO [{Variable_TempDb}].dbo.[__G_PROV1_SMETA_KS]
SELECT DISTINCT
LINK_UP     = gpsks.LINK_NEW
,OPER       = NULL
,NAME_OPER  = g1.NAME_OPER
,ORDERS     = 1
,LINK_DEP   = d.LINK
,[LINK_OLD] = g1.LINK
FROM {Variable_SmetaDb}.dbo.G_PROV g
INNER JOIN {Variable_SmetaDb}.dbo.G_PROV1 g1 ON g1.LINK_UP = g.LINK
LEFT JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_SMETA_KS] dsks ON dsks.LINK_OLD = G.DEP
LEFT JOIN [{Variable_WorkDb}].dbo.DEPARTMENTS d ON d.LINK = dsks.LINK_NEW
LEFT JOIN [{Variable_TempDb}].dbo.[__G_PROV_SMETA_KS] gpsks ON gpsks.LINK_OLD = g.LINK
WHERE 
(
	g.DATE_PROV >= @dDATE
	OR
	g.DATE_PROV IS NULL AND G.DATE >= @dDATE
)

INSERT INTO [{Variable_WorkDb}].dbo.G_PROV2
(LINK_UP, SUMMA, QUANTITY, PRICE, STORNO, LINK_SELF, NAME, ORDERS, ECON_OPER, [LINK_OLD], [ACC_DT], [ACC_KT], [DEP])
OUTPUT INSERTED.link, INSERTED.[LINK_OLD], INSERTED.[ACC_DT], INSERTED.[ACC_KT], INSERTED.[DEP]
INTO [{Variable_TempDb}].dbo.[__G_PROV2_SMETA_KS] ([LINK_NEW], [LINK_OLD], [ACC_DT], [ACC_KT], [DEP])
SELECT
LINK_UP     = g1sks.LINK_NEW
,SUMMA      = g2.SUMMA
,QUANTITY   = g2.QUANTITY
,PRICE      = CASE WHEN g2.QUANTITY <> 0 THEN g2.SUMMA / g2.QUANTITY ELSE 0 END
,STORNO     = g2.STORNO
,LINK_SELF  = NULL
,[NAME]     = g2.NAME
,ORDERS     = 1
,ECON_OPER  = NULL--(SELECT TOP 1 LINK FROM [{Variable_WorkDb}].dbo.BX_BPROV_VIBOR_ECON_OPER(sa12.LINK, sa22.LINK, DEFAULT, d.LINK))
,[LINK_OLD] = g2.LINK
,sa12.LINK 
,sa22.LINK 
,d.LINK
FROM {Variable_SmetaDb}.dbo.G_PROV g
INNER JOIN {Variable_SmetaDb}.dbo.G_PROV1 g1 ON g1.LINK_UP = g.LINK
INNER JOIN {Variable_SmetaDb}.dbo.G_PROV2 g2 ON g2.LINK_UP = g1.LINK

LEFT JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_SMETA_KS] dsks ON dsks.LINK_OLD = G.DEP

LEFT JOIN {Variable_SmetaDb}.dbo.G_PROV_AP gpa1 ON gpa1.LINK_UP = g2.LINK AND gpa1.DB_KR = 0
LEFT JOIN {Variable_SmetaDb}.dbo.S_ACCOUNTS sa11 ON sa11.LINK = gpa1.ACCOUNT
LEFT JOIN [{Variable_WorkDb}].dbo.S_ACCOUNTS sa12 ON sa12.CODE = sa11.CODE {WORK_COLLATE} AND sa12.LINK_DEP = {LINK_DEP_MAIN}

LEFT JOIN {Variable_SmetaDb}.dbo.G_PROV_AP gpa2 ON gpa2.LINK_UP = g2.LINK AND gpa2.DB_KR = 1
LEFT JOIN {Variable_SmetaDb}.dbo.S_ACCOUNTS sa21 ON sa21.LINK = gpa2.ACCOUNT
LEFT JOIN [{Variable_WorkDb}].dbo.S_ACCOUNTS sa22 ON sa22.CODE = sa21.CODE {WORK_COLLATE} AND sa22.LINK_DEP = {LINK_DEP_MAIN}

LEFT JOIN [{Variable_TempDb}].dbo.[__G_PROV1_SMETA_KS] g1sks ON g1sks.LINK_OLD = g1.LINK
LEFT JOIN [{Variable_WorkDb}].dbo.DEPARTMENTS d ON d.LINK = dsks.LINK_NEW
WHERE 
(
	g.DATE_PROV >= @dDATE
	OR
	g.DATE_PROV IS NULL AND G.DATE >= @dDATE
)

GO
-- 
INSERT INTO [{Variable_TempDb}].[dbo].[__VIBOR_ECON_OPER] ([ACC_DT], [ACC_KT], [DEP])
SELECT DISTINCT [ACC_DT], [ACC_KT], [DEP]
FROM [{Variable_TempDb}].dbo.[__G_PROV2_SMETA_KS]
GO

UPDATE [{Variable_TempDb}].[dbo].[__VIBOR_ECON_OPER]
SET [ECON_OPER] = (SELECT TOP 1 LINK FROM [{Variable_WorkDb}].dbo.BX_BPROV_VIBOR_ECON_OPER([ACC_DT], [ACC_KT], DEFAULT, [DEP]))
GO

UPDATE G2 SET
	G2.ECON_OPER = B.[ECON_OPER]
FROM
	[{Variable_WorkDb}].dbo.G_PROV2 G2
	INNER JOIN [{Variable_TempDb}].dbo.[__G_PROV2_SMETA_KS] A ON G2.LINK = A.LINK_NEW
	INNER JOIN {Variable_SmetaDb}.dbo.[G_PROV2] C ON C.LINK = A.LINK_OLD
	INNER JOIN [{Variable_TempDb}].[dbo].[__VIBOR_ECON_OPER] B ON A.[DEP] = B.[DEP] 
																AND ISNULL(A.[ACC_DT],0) = ISNULL(B.[ACC_DT],0)
																AND ISNULL(A.[ACC_KT],0) = ISNULL(B.[ACC_KT],0)
WHERE
	C.ECON_OPER IS NOT NULL															
GO



--UPDATE B SET B.ECON_OPER = NULL
--FROM 
--	b_bryansk..G_PROV2 A
--	INNER JOIN conv_bryansk.dbo.__G_PROV2_SMETA_KS T ON T.LINK_OLD = A.LINK
--	INNER JOIN bs_ryansk..G_PROV2 B ON B.LINK = T.LINK_NEW
--WHERE A.ECON_OPER IS NULL




COMMIT TRAN
GO

BEGIN TRAN

DECLARE @dDATE DATETIME
SET @dDATE = DATEADD(YEAR, DATEDIFF(YEAR, 0, GETDATE()), 0) --   

INSERT INTO [{Variable_WorkDb}].dbo.G_PROV_AP
(LINK_UP, DB_KR, ACCOUNT, KBK, EKR, DEP, SUB, EMP, NOMEN, INV, KAU, DEP_ACC, TMC,
INDATE, SGU, AP1, AP2, AP3, AP4, AP5, AP6)
SELECT 
LINK_UP     = g2sks.LINK_NEW
,DB_KR      = gpa.DB_KR
,ACCOUNT    = sa2.LINK
,KBK        = kksks.LINK_NEW
,EKR        = ekr2.LINK
,DEP        = dsks.LINK_NEW
,SUB        = s.LINK_UP
,EMP        = esks.LINK_NEW
,NOMEN      = nsks.LINK_NEW
,INV        = isks.LINK_NEW
,KAU        = kausks.LINK_NEW
,DEP_ACC    = DA1.LINK_NEW
,TMC        = TMC.LINK_NEW
,INDATE     = gpa.INDATE
,SGU        = k2.LINK
,AP1        = gpsks.LINK_NEW
,AP2        = dcsks.LINK_NEW
,AP3        = NULL
,AP4        = NULL
,AP5        = NULL 
,AP6        = NULL
FROM 
	{Variable_SmetaDb}.dbo.G_PROV g
	INNER JOIN {Variable_SmetaDb}.dbo.G_PROV1 g1 ON g1.LINK_UP = g.LINK
	INNER JOIN {Variable_SmetaDb}.dbo.G_PROV2 g2 ON g2.LINK_UP = g1.LINK
	INNER JOIN {Variable_SmetaDb}.dbo.G_PROV_AP gpa ON gpa.LINK_UP = g2.LINK

	LEFT JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_SMETA_KS] ddsks ON ddsks.LINK_OLD = G.DEP

	LEFT JOIN [{Variable_TempDb}].dbo.[__G_PROV2_SMETA_KS] g2sks ON g2sks.LINK_OLD = g2.LINK

	LEFT JOIN {Variable_SmetaDb}.dbo.S_ACCOUNTS sa ON sa.LINK = gpa.ACCOUNT
	LEFT JOIN [{Variable_WorkDb}].dbo.S_ACCOUNTS sa2 ON sa2.CODE =  CASE WHEN sa.ZABALANS = 1 AND ISNULL(sa.cSource {WORK_COLLATE},'') = '' THEN '0.' + sa.CODE {WORK_COLLATE} ELSE sa.CODE {WORK_COLLATE} END AND sa2.LINK_DEP = {LINK_DEP_MAIN}
	/*INNER JOIN [{Variable_WorkDb}].dbo.S_ACCOUNTS_NASTR san ON san.SINTH = sa.cSinth {WORK_COLLATE} AND san.ANALITH = sa.cAnalit {WORK_COLLATE}*/

	LEFT JOIN [{Variable_TempDb}].dbo.[__KL_KBK_SMETA_KS] kksks ON kksks.LINK_OLD = gpa.KBK
	LEFT JOIN 
	(SELECT RowNumber = ROW_NUMBER () OVER (PARTITION BY e.LINK_OLD ORDER BY e.LINK_OLD),*
	 FROM [{Variable_TempDb}].dbo.[__DEPARTMENTS_SMETA_KS] e) dsks ON dsks.LINK_OLD = gpa.DEP
	LEFT JOIN 
	(SELECT RowNumber = ROW_NUMBER () OVER (PARTITION BY e.LINK_OLD ORDER BY e.LINK_OLD),*
	 FROM [{Variable_TempDb}].dbo.[__EMPL_SMETA_KS] e) esks ON esks.LINK_OLD = gpa.EMP
	LEFT JOIN [{Variable_TempDb}].dbo.[__NOMENCLATURE_SMETA_KS] nsks ON nsks.LINK_OLD = gpa.NOMEN
	LEFT JOIN [{Variable_TempDb}].dbo.[__INVENTORY_SMETA_KS] isks ON isks.LINK_OLD = gpa.INV
	LEFT JOIN [{Variable_TempDb}].dbo.[__SUBDIV_SMETA_KS] ssks ON ssks.LINK_OLD = gpa.SUB
	LEFT JOIN [{Variable_WorkDb}].dbo.SUBDIV s ON ssks.LINK_NEW = s.LINK

	LEFT JOIN [{Variable_TempDb}].dbo.[__DOP_CLASSIF_SMETA_KS] dcsks ON dcsks.LINK_OLD = gpa.AP2
	LEFT JOIN [{Variable_TempDb}].dbo.[__KAU_SMETA_KS] kausks ON kausks.LINK_OLD = gpa.KAU

	LEFT JOIN {Variable_SmetaDb}.dbo.KOSGU k ON k.LINK = gpa.SGU
	LEFT JOIN [{Variable_WorkDb}].dbo.KOSGU k2 ON k2.CODE = k.CODE {WORK_COLLATE}

	LEFT JOIN {Variable_SmetaDb}.dbo.KOSGU ekr ON ekr.LINK = gpa.EKR
	LEFT JOIN [{Variable_WorkDb}].dbo.KOSGU ekr2 ON ekr2.CODE = ekr.CODE {WORK_COLLATE}

	--LEFT JOIN [{Variable_TempDb}].dbo.[__G_PROV_SMETA_KS] gpsks ON gpsks.LINK_OLD = gpa.AP1

	LEFT JOIN {Variable_SmetaDb}.dbo.OSNOV o ON o.LINK = gpa.AP1
	LEFT JOIN 
	(SELECT RowNumber = row_number () OVER ( PARTITION BY LINK_OLD ORDER BY LINK_OLD), * 
	 FROM [{Variable_TempDb}].dbo.G_DOC) gpsks ON gpsks.LINK_OLD = o.LINK_G_PROV AND gpsks.RowNumber = 1

	LEFT JOIN [{Variable_TempDb}].dbo.[__ACCOUNTS_SMETA_KS] DA1 ON DA1.LINK_OLD = gpa.DEP_ACC

	LEFT JOIN [{Variable_TempDb}].dbo.[__DICTIONARY_TMC_SMETA_KS] TMC ON TMC.LINK_OLD = gpa.TMC

WHERE 
	sa2.LINK IS NOT NULL
	AND (esks.RowNumber = 1 OR esks.RowNumber IS NULL)
	AND (dsks.RowNumber = 1 OR dsks.RowNumber IS NULL)
	AND NOT EXISTS (SELECT 1 FROM [{Variable_WorkDb}].dbo.S_ACCOUNTS WHERE LINK_SELF = sa2.LINK AND LINK_DEP = {LINK_DEP_MAIN})
	AND 
	(
	g.DATE_PROV >= @dDATE
	OR
	g.DATE_PROV IS NULL AND G.DATE >= @dDATE
	)


DECLARE @iROWCOUNT1 INT
SET @iROWCOUNT1 = @@ROWCOUNT


INSERT INTO [{Variable_TempDb}].dbo.[__Journal]
VALUES (' ', ' : ' + convert(nvarchar(100),ISNULL(@iROWCOUNT1,0)), '', 0)
--



--   
INSERT INTO [{Variable_WorkDb}].dbo.G_PROV_OTHER_OPER (DOC_LINK, TYPE_OPER)
select 
	DOC_LINK    = G.LINK,
	TYPE_OPER   = T2.LINK_NEW
from 
	[{Variable_WorkDb}].dbo.G_PROV G 
	INNER JOIN [{Variable_TempDb}].dbo.[__G_PROV_SMETA_KS] T1 ON T1.LINK_NEW = G.LINK
	INNER JOIN {Variable_SmetaDb}.dbo.G_PROV G1 ON  G1.LINK = T1.LINK_OLD
	INNER JOIN [{Variable_TempDb}].dbo.[__DOC_TYPES_] T2 ON G1.[OBJECT] = T2.LINK_OLD
WHERE 
	g.[OBJECT] = [{Variable_WorkDb}].dbo.obj_id('DOCUMENTS_OPER')
	AND
	NOT EXISTS (SELECT * FROM [{Variable_WorkDb}].dbo.G_PROV_OTHER_OPER O WHERE O.DOC_LINK = G.LINK )

--
UPDATE OO SET 
	OO.TYPE_OPER = T2.LINK_NEW
from 
	[{Variable_WorkDb}].dbo.G_PROV G 
	INNER JOIN [{Variable_WorkDb}].dbo.G_PROV_OTHER_OPER OO ON G.LINK = OO.DOC_LINK
	INNER JOIN [{Variable_TempDb}].dbo.[__G_PROV_SMETA_KS] T1 ON T1.LINK_NEW = G.LINK
	INNER JOIN {Variable_SmetaDb}.dbo.G_PROV G1 ON  G1.LINK = T1.LINK_OLD
	INNER JOIN {Variable_SmetaDb}.dbo.S_OBJECTS SO on SO.CODE {WORK_COLLATE} = 'COLUMN_OPER_KIND'
	INNER JOIN {Variable_SmetaDb}.dbo.G_PROV_DICTION GPD ON GPD.DOC_LINK = G1.LINK and GPD.OBJECT = SO.LINK
	INNER JOIN [{Variable_TempDb}].dbo.[__DOC_TYPES_RecordRef] T2 ON GPD.[DICTION] = T2.LINK_OLD
WHERE 
	g.[OBJECT] = [{Variable_WorkDb}].dbo.obj_id('DOCUMENTS_OPER')
-----------------------------------------------------------------------


----   
UPDATE g
SET g.SUMMA = ISNULL([{Variable_WorkDb}].dbo.CalcDocSumma(G.LINK), G.SUMMA)
FROM [{Variable_WorkDb}].dbo.G_PROV g
WHERE g.[OBJECT] = [{Variable_WorkDb}].dbo.obj_id('DOCUMENTS_OPER')
GO



--         
UPDATE G1 SET 
	G1.[COMMENT] = LEFT(LTRIM(RTRIM(P.TARGETTEXT)),254)
FROM 
	{Variable_SmetaDb}.dbo.G_PROV g
	INNER JOIN [{Variable_TempDb}].dbo.[__G_PROV_SMETA_KS] T1 ON T1.LINK_OLD = G.LINK	
	INNER JOIN [{Variable_WorkDb}].dbo.G_PROV G1 ON  G1.LINK = T1.LINK_NEW
	INNER JOIN {Variable_SmetaDb}.dbo.S_OBJECTS SO ON SO.LINK = G.[OBJECT]
	left join {Variable_SmetaDb}.dbo.FINANSE_PAYS P WITH (NOLOCK) on P.link = G.link
WHERE 
	SO.CODE {WORK_COLLATE} IN ('BB_ZAYAVKA_KR','DOCUMENTS_PAY')

------------------------------------------------------------------------

ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV2 DROP COLUMN [LINK_OLD]
GO
ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV1 DROP COLUMN [LINK_OLD]
GO
ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV DROP COLUMN [LINK_OLD]
GO
ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV2 DROP COLUMN [ACC_DT]
GO
ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV2 DROP COLUMN [ACC_KT]
GO
ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV2 DROP COLUMN [DEP]
GO

USE [{Variable_WorkDb}]
/*  */
UPDATE B SET 
	BEGINDATE = A.BEGINDATE,
	WORKDATE = A.WORKDATE,
	ENDDATE = A.ENDDATE
FROM
	[{Variable_WorkDb}].dbo.DEPARTMENTS_DATE B
	INNER JOIN [{Variable_WorkDb}].[dbo].[conv_DEPARTMENTS_DATE] A ON B.[DEP_LINK] = A.[DEP_LINK] AND A.[LINK_TASK] = B.[LINK_TASK]	
GO

IF exists(select * from sysobjects where id = object_id('[dbo].[conv_DEPARTMENTS_DATE]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	DROP TABLE [dbo].[conv_DEPARTMENTS_DATE]
GO

--    ,     
INSERT INTO [{Variable_WorkDb}].dbo.department_groups_ref(DEP_LINK,GROUP_LINK)
SELECT DISTINCT D.LINK, GR.LINK
FROM
	[{Variable_WorkDb}].dbo.V_DEP VD
	INNER JOIN [{Variable_WorkDb}].dbo.G_PROV G ON G.DEP = VD.LINK
	INNER JOIN [{Variable_WorkDb}].dbo.G_PROV1 G1 ON G1.LINK_UP = G.LINK
	INNER JOIN [{Variable_WorkDb}].dbo.G_PROV2 G2 ON G2.LINK_UP = G1.LINK
	INNER JOIN [{Variable_WorkDb}].dbo.G_PROV_AP GAP ON GAP.LINK_UP = G2.LINK
	INNER JOIN [{Variable_WorkDb}].dbo.DEPARTMENTS D ON D.LINK = GAP.DEP
	CROSS APPLY (SELECT TOP 1 LINK FROM [{Variable_WorkDb}].dbo.DEPARTMENT_GROUPS WHERE [SYS] = 4) GR
WHERE
	GAP.DEP IS NOT NULL
	AND
	NOT EXISTS (SELECT * FROM [{Variable_WorkDb}].dbo.department_groups_ref r WHERE R.DEP_LINK = D.LINK)
	AND
	GR.LINK IS NOT NULL


COMMIT TRAN
GO

EXEC [{Variable_WorkDb}].[dbo].X_SALDO_COMMITCHANGES
GO
