
USE {Variable_WorkDb}


IF exists(select * from sysobjects where id = object_id('[dbo].[conv_DEPARTMENTS_DATE]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	DROP TABLE [dbo].[conv_DEPARTMENTS_DATE]
GO

CREATE TABLE [dbo].[conv_DEPARTMENTS_DATE] (
	[LINK_TASK] int,
	[DEP_LINK] int,
	[BEGINDATE] datetime,
	[WORKDATE] datetime,
	[ENDDATE] datetime)
GO

INSERT INTO [{Variable_WorkDb}].[dbo].[conv_DEPARTMENTS_DATE]([LINK_TASK], [DEP_LINK], [BEGINDATE], [WORKDATE], [ENDDATE])
SELECT B.[LINK_TASK], B.[DEP_LINK], B.[BEGINDATE], B.[WORKDATE], B.[ENDDATE]
FROM 
	[{Variable_TempDb}].dbo.__DEPARTMENTS_SMETA_KS A
	INNER JOIN [{Variable_WorkDb}].dbo.DEPARTMENTS_DATE B ON B.DEP_LINK = A.LINK_NEW
GO

/*    ,    */
UPDATE B SET 
	BEGINDATE = '20000101',
	WORKDATE = DATEADD(DAY,-1,GETDATE()),
	ENDDATE = GETDATE()
FROM
	[{Variable_WorkDb}].dbo.DEPARTMENTS_DATE B
	INNER JOIN [{Variable_WorkDb}].[dbo].[conv_DEPARTMENTS_DATE] A ON B.[DEP_LINK] = A.[DEP_LINK] AND A.[LINK_TASK] = B.[LINK_TASK]	
GO

USE {Variable_TempDb}
GO
-- 
--   
IF not exists(select * from sysobjects where id = object_id('[dbo].[__G_PROV_SMETA_KS_FB_NAZN_127D]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__G_PROV_SMETA_KS_FB_NAZN_127D] (
	[LINK_NEW] int ,
	[LINK_OLD] int,
	[DATE] datetime)
ELSE
	IF COLUMNPROPERTY(object_id('[dbo].[__G_PROV_SMETA_KS_FB_NAZN_127D]'), 'DATE', 'AllowsNull') is NULL
		ALTER TABLE [dbo].[__G_PROV_SMETA_KS_FB_NAZN_127D] ADD [DATE] datetime 	

GO

IF  NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE [name] = 'IX__G_PROV_SMETA_KS')
CREATE INDEX [IX__G_PROV_SMETA_KS] ON [dbo].[__G_PROV_SMETA_KS_FB_NAZN_127D] (LINK_OLD)-- ON [INDEX]
GO


IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'LINK_OLD' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].G_PROV'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV DROP COLUMN [LINK_OLD]
	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].G_PROV ADD [LINK_OLD] INT NULL
GO

IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'LINK_OLD' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].OUT_TABLE_ROW'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].OUT_TABLE_ROW DROP COLUMN [LINK_OLD]
	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].OUT_TABLE_ROW ADD [LINK_OLD] INT NULL
GO


DECLARE @iOBJECT INT
SELECT @iOBJECT = LINK FROM [{Variable_WorkDb}].dbo.S_OBJECTS so WHERE so.CODE = 'FINANS_INCOME'

DECLARE @dDATE DATETIME, @DATE_CONV DATETIME
SET @dDATE = DATEADD(YEAR, DATEDIFF(YEAR, 0, GETDATE()), 0) --   
SET @DATE_CONV = GETDATE()

--   ,    	
INSERT INTO {Variable_WorkDb}.dbo.G_PROV
(NUMBER, DATE, [OBJECT], DATE_PROV, SUMMA, COMMENT, GET_STORE, DEP, ACC, LINK_OLD)
    OUTPUT INSERTED.LINK,INSERTED.LINK_OLD, @DATE_CONV
		 INTO {Variable_TempDb}.dbo.[__G_PROV_SMETA_KS_FB_NAZN_127D]

SELECT DISTINCT
	 NUMBER     = LTRIM(RTRIM(g.NUMBER))
	,DATE       = g.DATE
	,[OBJECT]   = @iOBJECT
	,DATE_PROV  = NULL
	,SUMMA      = g.SUMMA
	,COMMENT    = g.COMMENT
	,GET_STORE  = 0
	,DEP        = d.LINK
	,ACC        = D.MAIN_LINK
	,LINK_OLD   = g.LINK
FROM
	{Variable_SmetaDb}.dbo.G_PROV G
	INNER JOIN {Variable_SmetaDb}.dbo.S_OBJECTS SO1 ON SO1.LINK = g.[OBJECT]
	INNER JOIN {Variable_TempDb}.dbo.[__DEPARTMENTS_SMETA_KS] dsks ON dsks.LINK_OLD = G.DEP
	INNER JOIN {Variable_WorkDb}.dbo.DEPARTMENTS d ON d.LINK = dsks.LINK_NEW		
WHERE
	g.DATE >= @dDATE
	AND NOT EXISTS (SELECT * FROM {Variable_TempDb}.dbo.__G_PROV_SMETA_KS T WHERE T.LINK_OLD = G.LINK)
	AND SO1.CODE {WORK_COLLATE} = 'FB_NAZN_127D'

SET @DATE_CONV = (SELECT MAX(DATE) FROM {Variable_TempDb}.dbo.[__G_PROV_SMETA_KS_FB_NAZN_127D])

INSERT INTO {Variable_WorkDb}.[dbo].[OUT_TABLE_ROW] ([LINK_UP],[OBJECT],[ORDERS],[LINK_OPER],[COMMENT],[LINK_OLD])
SELECT 
	[LINK_UP] = C.LINK_NEW,
	[OBJECT] = {Variable_WorkDb}.dbo.OBJ_ID('FINANSE_TABLE'),
	[ORDERS] = 0,
	[LINK_OPER] = NULL,
	[COMMENT] = '',
	PT.LINK
FROM
	{Variable_TempDb}.dbo.[__G_PROV_SMETA_KS_FB_NAZN_127D] C
	INNER JOIN {Variable_SmetaDb}.dbo.FB_PLAN_TABLE PT ON PT.LINK_UP = C.LINK_OLD
WHERE 
	C.[DATE] = @DATE_CONV


INSERT INTO {Variable_WorkDb}.[dbo].[FINANSE] (LINK_UP,KBK,EKR,DOP_CL,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10,P11,P12,Y2,Y3,BO,COMMENT,SOURCE,KAU)
SELECT 
	[LINK_UP] = OTR.LINK,
	[KBK] = kksks.LINK_NEW,
	[EKR] = ekr2.LINK,
	[DOP_CL] = dcsks.LINK_new,
	[P1] = PT.SUMMA,
	[P2] = 0,
	[P3] = 0,
	[P4] = 0,
	[P5] = 0,
	[P6] = 0,
	[P7] = 0,
	[P8] = 0,
	[P9] = 0,
	[P10] = 0,
	[P11] = 0,
	[P12] = 0,
	[Y2] = 0,
	[Y3] = 0,
	[BO] = 0,
	[COMMENT] = 0,
	[SOURCE] = S.LINK,
	[KAU] = NULL
FROM
	{Variable_TempDb}.dbo.[__G_PROV_SMETA_KS_FB_NAZN_127D] C
	INNER JOIN {Variable_SmetaDb}.dbo.FB_PLAN_TABLE PT ON PT.LINK_UP = C.LINK_OLD
	INNER JOIN {Variable_WorkDb}.[dbo].[OUT_TABLE_ROW] OTR ON OTR.LINK_UP = C.LINK_NEW AND OTR.LINK_OLD = PT.LINK
	CROSS APPLY (SELECT TOP 1 LINK FROM [{Variable_WorkDb}].dbo.FIN_SOURCE FS WHERE FS.CODE = '1' AND FS.LINK_DEP = [{Variable_WorkDb}].dbo.getOwnDepLink()) S
	LEFT JOIN [{Variable_TempDb}].dbo.[__KL_KBK_SMETA_KS] kksks ON kksks.LINK_OLD = PT.VKR
	LEFT JOIN [{Variable_WorkDb}].dbo.KOSGU ekr2 ON ekr2.CODE = PT.[EKR_CODE] {WORK_COLLATE}
	LEFT JOIN [{Variable_TempDb}].dbo.[__DOP_CLASSIF_SMETA_KS] dcsks ON dcsks.LINK_OLD = PT.DOP_CL


DECLARE @iROWCOUNT1 INT
SET @iROWCOUNT1 = @@ROWCOUNT


INSERT INTO [{Variable_TempDb}].dbo.[__Journal]
VALUES ('  ', ' : ' + convert(nvarchar(100),ISNULL(@iROWCOUNT1,0)), '', 0)
--


ALTER TABLE {Variable_WorkDb}.[dbo].G_PROV DROP COLUMN [LINK_OLD]
GO
ALTER TABLE {Variable_WorkDb}.[dbo].OUT_TABLE_ROW DROP COLUMN [LINK_OLD]
GO


USE [{Variable_WorkDb}]
/*  */
UPDATE B SET 
	BEGINDATE = A.BEGINDATE,
	WORKDATE = A.WORKDATE,
	ENDDATE = A.ENDDATE
FROM
	[{Variable_WorkDb}].dbo.DEPARTMENTS_DATE B
	INNER JOIN [{Variable_WorkDb}].[dbo].[conv_DEPARTMENTS_DATE] A ON B.[DEP_LINK] = A.[DEP_LINK] AND A.[LINK_TASK] = B.[LINK_TASK]	
GO

IF exists(select * from sysobjects where id = object_id('[dbo].[conv_DEPARTMENTS_DATE]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
	DROP TABLE [dbo].[conv_DEPARTMENTS_DATE]
GO



EXEC [{Variable_WorkDb}].[dbo].X_SALDO_COMMITCHANGES
GO
				