-- 
--   
USE {Variable_TempDb}
GO

IF not exists(select * from sysobjects where id = object_id('[dbo].[__DEPARTMENTS_BANKS_SMETA_KS]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
CREATE TABLE [dbo].[__DEPARTMENTS_BANKS_SMETA_KS] (
	[LINK_NEW] int ,
	[LINK_OLD] INT )
ELSE 
	DELETE FROM [dbo].[__DEPARTMENTS_BANKS_SMETA_KS]
GO

set xact_abort on
BEGIN TRAN

IF Exists(select 1 from {Variable_WorkDb}.sys.columns where Name = N'LINK_OLD' and Object_ID = Object_ID(N'[{Variable_WorkDb}].[dbo].DEPARTMENTS'))
	BEGIN
	   ALTER TABLE [{Variable_WorkDb}].[dbo].DEPARTMENTS DROP COLUMN [LINK_OLD]
	END
GO
 ALTER TABLE [{Variable_WorkDb}].[dbo].DEPARTMENTS ADD [LINK_OLD] INT NULL
GO

SELECT DISTINCT b2.LINK, b2.BIK {WORK_COLLATE} AS BIK 
INTO #BANKS		
FROM	
	{Variable_SmetaDb}.dbo.BANKS b2
	INNER JOIN {Variable_SmetaDb}.dbo.DEPARTMENT_ACCOUNTS da ON da.BANK_LINK = b2.LINK
	INNER JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_SMETA_KS] dsks ON dsks.LINK_OLD = da.LINK_UP
	INNER JOIN [{Variable_WorkDb}].dbo.DEPARTMENTS d ON d.LINK = dsks.LINK_NEW
GO

--      ,    
INSERT INTO [{Variable_TempDb}].[dbo].[__DEPARTMENTS_BANKS_SMETA_KS] ([LINK_NEW], [LINK_OLD])
SELECT DISTINCT B.LINK, A.[LINK]	
FROM 
	#BANKS A
	INNER JOIN 
	(
		SELECT B.LINK, B.BIK, NUM = ROW_NUMBER() OVER (PARTITION BY B.BIK ORDER BY B.LINK)
		FROM 
			[{Variable_WorkDb}].dbo.BANKS B
			INNER JOIN [{Variable_WorkDb}].dbo.DEPARTMENTS D ON D.LINK = B.LINK
	) B ON B.BIK = A.BIK
WHERE 
	B.NUM = 1
	AND
	LEN(LTRIM(RTRIM(ISNULL(A.BIK,'')))) > 0
	AND
	LEN(LTRIM(RTRIM(ISNULL(B.BIK,'')))) > 0	
	AND
	NOT EXISTS (SELECT * FROM [{Variable_TempDb}].[dbo].[__DEPARTMENTS_BANKS_SMETA_KS] T WHERE T.LINK_OLD = A.[LINK])
GO
	
--     
INSERT INTO [{Variable_WorkDb}].dbo.DEPARTMENTS WITH (ROWLOCK) (
 	-- LINK -- this column value is auto-generated
 	CODE,
 	[NAME],
 	FULL_NAME,
 	INN,
 	KPP,
 	OKPO,
 	KLADR_LINK,
 	HOUSE,
 	FLAT,
 	VED_LINK,
 	MAIN_LINK,
 	REGCODE,
 	OKATO,
 	FIN_CODE,
 	TOFK_LINK,
 	PFNUMBER,
 	BUDG,
 	BRON,
 	PREFIX,
 	OGRN,
 	IMNS_LINK,
 	ORD_HEAD,
 	SBK_REGNUM,
 	SBK_DOCNUM,
 	SBK_DOCDATE,
 	SBK_LINK,
 	ZB,
 	HIGH_LINK,
 	PERS_LINK,
 	INN_DOP,
 	IS_RBS,
 	FO_LINK,
 	N_ACC_LINK,
 	EGRUL,
 	CODE_UBP,
 	FSS_REG_NUM,
 	FSS_KOD_P,
 	FSS_KOD_DOP,
 	OKOPF,
 	OKFS,
 	TFOMS_REG_NUM,
 	TFOMS_KT,
 	EMail,
 	FSS_KP_P1,
 	FSS_KP_P2,
 	FSS_KP_P3,
 	CORP,
 	UCHR_LINK,
 	CODE_TOFK,
 	PHONE,
 	-- STAMP -- this column value is auto-generated
 	[GUID],
 	ROW_ID,
 	[ACTION],
 	[TYPE], [LINK_DEP],[LINK_OLD]) 
OUTPUT INSERTED.LINK, INSERTED.LINK_OLD
	INTO [{Variable_TempDb}].[dbo].[__DEPARTMENTS_BANKS_SMETA_KS]
SELECT DISTINCT
	CODE          = RIGHT(ISNULL(LTRIM(RTRIM( b.BIK )),''),10), 
	[NAME]        = LEFT(ISNULL(LTRIM(RTRIM( b.NAME )),''),254),
	FULL_NAME     = LEFT(ISNULL(LTRIM(RTRIM( b.FNAME )),''),254),
	INN           = '',
 	KPP           = '',
 	OKPO          = '',
 	KLADR_LINK    = NULL,
 	HOUSE         = '',
 	FLAT          = '',
 	VED_LINK      = NULL,
 	MAIN_LINK     = NULL,
 	REGCODE       = '',
 	OKATO         = '',
 	FIN_CODE      = '',
 	TOFK_LINK     = NULL,
 	PFNUMBER      = '',
 	BUDG          = '',
 	BRON          = 0,
 	PREFIX        = '',
 	OGRN          = '',
 	IMNS_LINK     = NULL,
 	ORD_HEAD      = '',
 	SBK_REGNUM    = NULL,
 	SBK_DOCNUM    = '',
 	SBK_DOCDATE   = NULL,
 	SBK_LINK      = NULL,
 	ZB            = NULL,
 	HIGH_LINK     = NULL,
 	PERS_LINK     = NULL,
 	INN_DOP       = '',
 	IS_RBS        = 0,
 	FO_LINK       = NULL,
 	N_ACC_LINK    = NULL,
 	EGRUL         = '',
 	CODE_UBP      = '',
 	FSS_REG_NUM   = '',
 	FSS_KOD_P     = '',
 	FSS_KOD_DOP   = '',
 	OKOPF         = '',
 	OKFS          = '',
 	TFOMS_REG_NUM = '',
 	TFOMS_KT      = '',
 	EMail         = '',
 	FSS_KP_P1     = NULL,
 	FSS_KP_P2     = NULL,
 	FSS_KP_P3     = NULL,
 	CORP          = '',
 	UCHR_LINK     = NULL,
 	CODE_TOFK     = '',
 	PHONE         = '',
 	[GUID]        = NULL,
 	ROW_ID        = NULL,
 	[ACTION]      = NULL,
 	[TYPE]        = 0,
 	[LINK_DEP]    = [{Variable_WorkDb}].dbo.getOwnDepLink(), /*  */
 	LINK_OLD      = b.LINK
		FROM (SELECT 
		  RowNumber = ROW_NUMBER () OVER (PARTITION BY b2.LINK, b2.BIK ORDER BY b2.LINK), 
		  b2.LINK, b2.BIK, b2.NAME,
		  b2.FNAME, b2.KS, b2.CITY, 
		  b2.OSB, b2.FILIAL, b2.FILIAL_NAME, 
		  b2.DOGOVOR,
		  b2.DATE_DOG, d.LINK_DEP
		FROM {Variable_SmetaDb}.dbo.BANKS b2
  LEFT JOIN {Variable_SmetaDb}.dbo.DEPARTMENT_ACCOUNTS da ON da.BANK_LINK = b2.LINK
  LEFT JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_SMETA_KS] dsks ON dsks.LINK_OLD = da.LINK_UP
  LEFT JOIN [{Variable_WorkDb}].dbo.DEPARTMENTS d ON d.LINK = dsks.LINK_NEW
		) b
WHERE 
	b.RowNumber = 1
	AND NOT EXISTS ( SELECT * FROM [{Variable_TempDb}].[dbo].[__DEPARTMENTS_BANKS_SMETA_KS] T WHERE T.LINK_OLD = b.LINK)
    
--    
DECLARE @iROWCOUNT INT
SET @iROWCOUNT = @@ROWCOUNT

DECLARE @iROWS_NOT_COPIED BIGINT
SET @iROWS_NOT_COPIED = @@ROWCOUNT
INSERT INTO [{Variable_TempDb}].dbo.[__Journal]
VALUES (' " (-)"', ' : ' + convert(nvarchar(100),@iROWCOUNT), '',0)
--

ALTER TABLE [{Variable_WorkDb}].[dbo].DEPARTMENTS DROP COLUMN LINK_OLD
GO

---
INSERT INTO [{Variable_WorkDb}].dbo.BANKS WITH (ROWLOCK) 
	(LINK, BIK, KS, CITY, OSB, FILIAL, FILIAL_NAME, [NAME]) 
SELECT 
	LINK          = SB.LINK_NEW, 
	BIK           = RIGHT(ISNULL(LTRIM(RTRIM( b.BIK )),''),10),
	KS            = LEFT(ISNULL(LTRIM(RTRIM( b.KS )),''),20),
	CITY          = LEFT(ISNULL(LTRIM(RTRIM( b.CITY )),''),100),
	OSB           = b.OSB,
	FILIAL        = b.FILIAL,
	FILIAL_NAME   = b.FILIAL_NAME,
	[NAME]        = LEFT(ISNULL(LTRIM(RTRIM( b.NAME )),''),100)
FROM 
	(SELECT
	  RowNumber = ROW_NUMBER () OVER (PARTITION BY b2.LINK, b2.BIK ORDER BY b2.LINK), b2.LINK, b2.BIK, b2.NAME,
	  b2.FNAME, b2.KS, b2.CITY, b2.OSB, b2.FILIAL, b2.FILIAL_NAME, b2.DOGOVOR,
	  b2.DATE_DOG, d.LINK_DEP
	FROM
		{Variable_SmetaDb}.dbo.BANKS b2
		LEFT JOIN {Variable_SmetaDb}.dbo.DEPARTMENT_ACCOUNTS da ON da.BANK_LINK = b2.LINK
		LEFT JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_SMETA_KS] dsks ON dsks.LINK_OLD = da.LINK_UP
		LEFT JOIN [{Variable_WorkDb}].dbo.DEPARTMENTS d ON d.LINK = dsks.LINK_NEW
	) b
	INNER JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_BANKS_SMETA_KS] sb ON sb.LINK_OLD = b.LINK
WHERE 
	b.RowNumber = 1
	AND NOT EXISTS ( SELECT * FROM [{Variable_WorkDb}].dbo.BANKS T WHERE T.LINK = SB.LINK_NEW)

----
DECLARE @iGROUP_LINK INT, @IERROR INT
SELECT @iGROUP_LINK = link FROM [{Variable_WorkDb}].dbo.DEPARTMENT_GROUPS dg WHERE dg.SYS = 6

INSERT INTO [{Variable_WorkDb}].dbo.DEPARTMENT_GROUPS_REF WITH (ROWLOCK) 
	(DEP_LINK, GROUP_LINK) 
SELECT DISTINCT
	sb.link_NEW, @iGROUP_LINK
FROM 
	[{Variable_TempDb}].dbo.[__DEPARTMENTS_BANKS_SMETA_KS] sb
WHERE
	NOT EXISTS (SELECT * FROM [{Variable_WorkDb}].dbo.DEPARTMENT_GROUPS_REF T WHERE T.DEP_LINK = sb.link_NEW AND T.[GROUP_LINK] = @iGROUP_LINK)


SELECT @iError = @@ERROR
IF @iError <> 0
BEGIN
	ROLLBACK
	PRINT('  ' + convert(varchar(254),@iERROR) )
	RAISERROR('     ', 11,1)
END
		
COMMIT TRAN


