USE [{Variable_WorkDb}]
GO


/*
   ""
        

SELECT LINK_DEP, CODE, BUDG_NAME, COUNT(*)
FROM
	dbo.BI_DICTION_ADMIN_BS B
GROUP BY
	LINK_DEP, CODE, BUDG_NAME
HAVING
	COUNT(*) > 1

*/

set xact_abort on
BEGIN TRAN


SET NOCOUNT ON

declare @RID UniqueIdentifier
execute dbo.newrid @RID=@RID output

DECLARE @CODE_ADMIN VARCHAR(254), @BUDG_NAME VARCHAR(2000), @LINK_DEP INT, @LINK INT

DECLARE @Cur1 CURSOR

SET @Cur1 = CURSOR FORWARD_ONLY

FOR 

	SELECT 
		LINK_DEP, LINK, CODE, BUDG_NAME
	FROM
		(
		SELECT LINK, LINK_DEP, CODE, BUDG_NAME, NUM = ROW_NUMBER() OVER (PARTITION BY CODE, BUDG_NAME ORDER BY LINK)
		FROM
			dbo.BI_DICTION_ADMIN_BS A
		WHERE
			EXISTS ( SELECT LINK_DEP, CODE, BUDG_NAME
						FROM
							dbo.BI_DICTION_ADMIN_BS B
						WHERE
							B.LINK_DEP = A.LINK_DEP
							AND
							B.CODE = A.CODE	
							AND
							ISNULL(B.BUDG_NAME,'') = ISNULL(A.BUDG_NAME,'')
						GROUP BY
							LINK_DEP, CODE, BUDG_NAME
						HAVING
							COUNT(*) > 1
					)		
		) T 
	WHERE
		T.NUM = 1	
	
OPEN @Cur1
FETCH NEXT FROM @Cur1 INTO @LINK_DEP, @LINK, @CODE_ADMIN, @BUDG_NAME
WHILE (@@fetch_status <> -1)
BEGIN
	IF (@@fetch_status <> -2)
	BEGIN

		PRINT @CODE_ADMIN
		
		insert into dbo.sys_link ([rid], [link]) 
		SELECT @RID, T.LINK FROM dbo.BI_DICTION_ADMIN_BS T WHERE T.LINK_DEP = @LINK_DEP AND T.CODE = @CODE_ADMIN AND ISNULL(T.BUDG_NAME,'') = ISNULL(@BUDG_NAME,'')
		
		exec dbo.XA_MERGE_REC @OBJ_CODE = 'BI_DICTION_ADMIN_BS', @nMainLink = @LINK, @RID = @RID
		
		DELETE FROM dbo.sys_link WHERE [rid] = @RID
		
	END

	FETCH NEXT FROM @Cur1 INTO @LINK_DEP, @LINK, @CODE_ADMIN, @BUDG_NAME
END

CLOSE @Cur1
DEALLOCATE @Cur1

SET NOCOUNT OFF

COMMIT TRAN
GO
