
--  NOMENSEARCH
EXEC [{Variable_WorkDb}].dbo.GENERATE_GRP_ACTIVE_TREE_PATH
GO
---    ---
EXEC [{Variable_WorkDb}].dbo.XD_CORRECT_PROV_FULL_BY_XO_BUF
GO
---    
EXECUTE [{Variable_WorkDb}].dbo.XA_ADJUST_EMPL_POST
GO
---    
EXECUTE [{Variable_WorkDb}].dbo.XA_ADJUST_SUBDIV
GO

EXEC [{Variable_WorkDb}].dbo.GENERATE_ACCOUNT_SUBTREE
GO
exec [{Variable_WorkDb}].dbo.GEN_NGRAMS_TABLES 'NOMENCLATURE', 'name', 2
GO
exec [{Variable_WorkDb}].dbo.GEN_NGRAMS_TABLES 'post', 'name', 2
GO
exec [{Variable_WorkDb}].dbo.GEN_NGRAMS_TABLES 'DEPARTMENTS', 'full_name', 5
GO

exec [{Variable_WorkDb}].dbo.GENERATE_NOMEN_SUBTREE
GO

EXEC [{Variable_WorkDb}].dbo.GEN_CORR_GROUPS_STR
GO
--
EXEC [{Variable_WorkDb}].dbo.GEN_COR_ACC_GROUP 
GO

/*   */
--
--       
EXECUTE [{Variable_WorkDb}].dbo.XA_UPDATE_G_PROV_KAU
GO

--    .   ,      G_PROV_FIELDS
EXEC [{Variable_WorkDb}].dbo.XA_UPDATE_G_PROV_DOP_CLASSIF
GO

--      ,      G_PROV_FIELDS
EXEC [{Variable_WorkDb}].dbo.XA_UPDATE_G_PROV_EKR
GO

--       ,      G_PROV_FIELDS
EXEC [{Variable_WorkDb}].dbo.XA_UPDATE_G_PROV_FIN_SOURCE
GO

--      ,      G_PROV_FIELDS
EXEC [{Variable_WorkDb}].dbo.XA_UPDATE_G_PROV_KBK
GO

--    -  ,      G_PROV_FIELDS
EXEC [{Variable_WorkDb}].dbo.XA_UPDATE_G_PROV_DOCBASE
GO

--    -  ,      G_PROV_FIELDS
EXEC [{Variable_WorkDb}].dbo.XA_UPDATE_DOC_NAME_ALL
GO


/*    */
USE {Variable_WorkDb}
GO

IF OBJECT_ID('TEMPDB..#TL','U') IS NOT NULL
	DROP TABLE #TL
GO

CREATE TABLE #TL (LINK INT)
INSERT INTO #TL (LINK) SELECT LINK_NEW FROM [{Variable_TempDb}].dbo.[__DEPARTMENTS_SMETA_KS]
GO

DECLARE @LINK_DOC_NASTR INT

SET @LINK_DOC_NASTR = 
(
	SELECT TOP 1 DN.LINK
	FROM {Variable_WorkDb}.dbo.DOC_NASTR DN INNER JOIN {Variable_WorkDb}.dbo.DOCUMENTS_PAY_ACC_OPTIONS N ON N.LINK_UP = DN.LINK
	WHERE DN.DEP_LINK = {Variable_WorkDb}.dbo.getOwnDepLink() AND DN.[OBJECT] = {Variable_WorkDb}.dbo.obj_id('DOCUMENTS_PAY')
)	
IF @LINK_DOC_NASTR IS NOT NULL
	EXEC {Variable_WorkDb}.dbo.XD_DOC_NASTR_SETTING_ACC_S_I @OBJ_CODE = 'XD_DOC_NASTR_SETTING_ACC', @LINK_DOC_NASTR = @LINK_DOC_NASTR, @cTable = '#TL' 

IF OBJECT_ID('TEMPDB..#TL','U') IS NOT NULL
	DROP TABLE #TL
GO

exec dbo.DEPARTMENTS_CHECK_DOUBLE 1
GO
exec dbo.DEPARTMENTS_CHECK_DOUBLE 2
GO
exec dbo.DEPARTMENTS_CHECK_DOUBLE 3
GO
exec dbo.DICTIONARY_BANK_CHECK_DOUBLE 4
GO


USE {Variable_WorkDb}
GO

ALTER TABLE dbo.DEPARTMENTS DISABLE TRIGGER ALL
GO

	update [{Variable_WorkDb}].dbo.departments
	set KPP = '' 
	where type = 1 and ( isnull(kpp,'') <> '' OR isnull(kpp,'') <> '0' )

	--   ,   
	UPDATE D SET D.MAIN_LINK = SA.LINK
	FROM
		[{Variable_WorkDb}].dbo.DEPARTMENTS D
		INNER JOIN (SELECT LINK_UP, LINK, CNT = COUNT(*) OVER (PARTITION BY LINK_UP)
					 FROM [{Variable_WorkDb}].dbo.DEPARTMENT_ACCOUNTS) SA ON D.LINK = SA.LINK_UP AND SA.CNT = 1
	WHERE
		D.MAIN_LINK IS NULL

ALTER TABLE dbo.DEPARTMENTS ENABLE TRIGGER ALL
GO


-- 
INSERT INTO [{Variable_WorkDb}].dbo.[MEASURE]([CODE], [SNAME], [NAME], [LINK_DEP])
SELECT 
	[CODE] = '796', [SNAME] = '', [NAME] = '', [LINK_DEP] = CB.[LINK_CB]
FROM
	(SELECT DISTINCT LINK_CB FROM [{Variable_WorkDb}].dbo.V_DEP) CB
WHERE
	NOT EXISTS (SELECT * FROM [{Variable_WorkDb}].dbo.[MEASURE] M WHERE M.[LINK_DEP] = CB.[LINK_CB] AND M.[SNAME] = '')

--   
UPDATE N SET N.[UM] = M.LINK
FROM
	[{Variable_WorkDb}].[dbo].[INVENTORY]  I
	INNER JOIN [{Variable_WorkDb}].[dbo].[NOMENCLATURE] N ON I.[NOMENCLATURE] = N.[LINK]
	INNER JOIN [{Variable_WorkDb}].[dbo].[MEASURE] M ON M.[LINK_DEP] = N.[LINK_DEP] AND M.[SNAME] = ''
WHERE
	N.[UM] IS NULL

--    101 
UPDATE N SET N.[UM] = M.LINK
FROM
	[{Variable_WorkDb}].[dbo].[NOMENCLATURE] N
	INNER JOIN [{Variable_WorkDb}].[dbo].[GROUP_ACTIVE] G ON N.[GROUP_INV] = G.[LINK]
	INNER JOIN [{Variable_WorkDb}].[dbo].[S_ACCOUNTS] SA ON G.ACCOUNT_B = SA.LINK AND SA.cSINTH = '101'
	INNER JOIN [{Variable_WorkDb}].[dbo].[MEASURE] M ON M.[LINK_DEP] = N.[LINK_DEP] AND M.[SNAME] = ''
WHERE
	N.[UM] IS NULL
GO


--     
UPDATE N SET N.[UM] = M.LINK
FROM
	[{Variable_WorkDb}].[dbo].SALDO S
	INNER JOIN [{Variable_WorkDb}].[dbo].[INVENTORY] I ON I.LINK = S.INV 
	INNER JOIN [{Variable_WorkDb}].[dbo].[NOMENCLATURE] N ON I.NOMENCLATURE = N.LINK
	INNER JOIN [{Variable_WorkDb}].[dbo].[MEASURE] M ON M.[LINK_DEP] = N.[LINK_DEP] AND M.[SNAME] = ''
WHERE
	 N.[UM] IS NULL
GO

UPDATE N SET N.[UM] = M.LINK
FROM
	[{Variable_WorkDb}].[dbo].SALDO_OPERATIVE S
	INNER JOIN [{Variable_WorkDb}].[dbo].[INVENTORY] I ON I.LINK = S.INV 
	INNER JOIN [{Variable_WorkDb}].[dbo].[NOMENCLATURE] N ON I.NOMENCLATURE = N.LINK
	INNER JOIN [{Variable_WorkDb}].[dbo].[MEASURE] M ON M.[LINK_DEP] = N.[LINK_DEP] AND M.[SNAME] = ''
WHERE
	 N.[UM] IS NULL
GO


--      
EXECUTE [{Variable_WorkDb}].dbo.XA_AUTO_FILL_KL_KBK_IVF
GO
EXECUTE [{Variable_WorkDb}].dbo.XA_AUTO_FILL_KL_KBK_KD
GO
EXECUTE [{Variable_WorkDb}].dbo.XA_AUTO_FILL_KL_VKR
GO
