--  -
set xact_abort on
BEGIN TRAN
--
/*
{Variable_TempDb} =	bs_kir_rp_tmp
{Variable_WorkDb} =	BS_KIR_RP
{Variable_SmetaDb} =	b_kir_rp
{LINK_DEP_MAIN}	= 296172
*/

--
USE {Variable_WorkDb}
GO

DISABLE TRIGGER ALL ON dbo.X_ACCESS_DEP
GO

DECLARE
	@WorkId BIGINT,

	@SID	VARBINARY (85),
	@NAME	VARCHAR (128),
	@isNtUser	INT,
	
	@UID	SMALLINT,

	@U_FIO	VARCHAR (254),
	@U_POST	VARCHAR (254),
	@U_PHONE	VARCHAR (254),
	
	@COUNT_USERS	INT

SET @WorkId = POWER(2, [dbo].GET_VAL_INT('PROJECT', 'WORK_PLACE_ID', null))

-- 
IF OBJECT_ID ('TEMPDB..#S_USERS') IS NOT NULL
	EXEC ('DROP TABLE #S_USERS')
	
CREATE TABLE #S_USERS
	(
	LOGINAME	VARCHAR (128)
	)

INSERT INTO #S_USERS
SELECT
	T1.NAME
FROM dbo.[SYSUSERS] T1

UNION

SELECT
	T1.LOGINAME
FROM dbo.S_USERS T1

SET @COUNT_USERS = 0

DECLARE #CURS1 CURSOR LOCAL STATIC 
FOR
	SELECT
		T1.[UID],
		T1.[SID],
		CONVERT (VARCHAR (254), T1.NAME),
		T1.isNtUser,
		EMP.FIO,
		EMP.POST_NAME,
		EMP.PHONE_WORK
	FROM {Variable_SmetaDb}.[dbo].[SYSUSERS] T1
	LEFT JOIN {Variable_SmetaDb}.[dbo].WHO_IS_WHO T2 ON T2.[SID] = T1.[SID]
	LEFT JOIN {Variable_SmetaDb}.[dbo].KU_EMPL_PLACING EMP ON EMP.LINK = T2.[USER_REF]
	WHERE
		T1.[UID] > 4 AND T1.[UID] < 16384
		AND T1.isntgroup = 0
		AND T1.issqlrole = 0		
		AND EXISTS
				(
				SELECT 1
				FROM {Variable_SmetaDb}..sysmembers TTT1
				INNER JOIN {Variable_SmetaDb}.dbo.[SYSUSERS] TTT2 ON
					(
					TTT2.[UID] = TTT1.[GROUPUID]
					AND TTT2.ISSQLROLE = 1
					AND TTT2.NAME IN ('-', ' ')
					)
				WHERE TTT1.[MEMBERUID] = T1.[UID]
				)
		AND EXISTS
				(
				SELECT 1
				FROM {Variable_SmetaDb}.[dbo].USER_DEP_ACCESS TTT
				WHERE TTT.[USER_SID] = T1.[SID]
					AND TTT.ACCESS = 1
					AND TTT.[DENY] = 0
				)
		AND NOT EXISTS
				(
				SELECT 1
				FROM #S_USERS TTT
				WHERE TTT.LOGINAME = T1.NAME
				)
			
OPEN #CURS1

FETCH FIRST FROM #CURS1
	INTO
		@UID,
		@SID,
		@NAME,
		@isNtUser,
		@U_FIO,
		@U_POST,
		@U_PHONE

WHILE @@FETCH_STATUS = 0
BEGIN
	SET @COUNT_USERS = @COUNT_USERS + 1

 	EXEC [dbo].admin_add_user
		@cLoginName	=	@NAME,  
		@cPassword	=	NULL,  
		@AdmSys = 0,  
		@AdmArm = 1,  
		@AdmArmBank = 0,  
		@cNote = ' -',  
		@cMode	= 'default',  
		@nBitComplexId = @WorkId,  
		@NoOutput = 1

	--    --	
	INSERT INTO [dbo].X_ACCESS_DEP
		(
		USERS,
		LINK_DEP,
		VALUE
		)
	SELECT
		T1.[UID],
		DEP.LINK,
		4101
	FROM [dbo].[S_USERS] T1
	INNER JOIN {Variable_SmetaDb}.[dbo].USER_DEP_ACCESS T2 ON (T2.[USER_SID] = @SID)	
	INNER JOIN {Variable_TempDb}.[dbo].[__DEPARTMENTS_SMETA_KS] T3 ON (T3.LINK_OLD = T2.DEP_LINK)
	INNER JOIN [dbo].DEPARTMENTS DEP ON (DEP.LINK = T3.LINK_NEW)
	WHERE T1.LOGINAME = @NAME
		AND TYPE_DESC = 'SQL_USER'
		AND T2.ACCESS = 1 AND T2.[DENY] = 0
		AND NOT EXISTS 
					(
					SELECT 1
					FROM [dbo].X_ACCESS_DEP TTT
					WHERE TTT.USERS = T1.[UID]
						AND TTT.LINK_DEP = DEP.LINK
					)
	
	--  --
	UPDATE T1
	SET
		FIO	=	ISNULL (@U_FIO, ''),
		POST	=	ISNULL (@U_POST, ''),
		PHONE	=	ISNULL (@U_PHONE, '')
	FROM [dbo].[S_USERS] T1
	WHERE T1.LOGINAME = @NAME

	--    --
	EXECUTE sp_addrolemember '-', @NAME
	
	IF EXISTS
			(
			SELECT 1
			FROM {Variable_SmetaDb}..sysmembers TTT1
			INNER JOIN {Variable_SmetaDb}.dbo.[SYSUSERS] TTT2 ON
				(
				TTT2.[UID] = TTT1.[GROUPUID]
				AND TTT2.ISSQLROLE = 1
				AND TTT2.NAME IN (' ')
				)
			WHERE TTT1.[MEMBERUID] = @UID
			)
		EXECUTE sp_addrolemember ' ', @NAME

	FETCH NEXT FROM #CURS1
		INTO
			@UID,
			@SID,
			@NAME,
			@isNtUser,
			@U_FIO,
			@U_POST,
			@U_PHONE
END

CLOSE #CURS1
DEALLOCATE #CURS1

--SELECT @COUNT_USERS
--    
INSERT INTO {Variable_TempDb}.dbo.[__Journal]
VALUES (' ""', ' : ' + convert(nvarchar(100), @COUNT_USERS), '', 0)

USE {Variable_WorkDb}
GO

ENABLE TRIGGER ALL ON dbo.X_ACCESS_DEP
GO

IF OBJECT_ID ('TEMPDB..#S_USERS') IS NOT NULL
	EXEC ('DROP TABLE #S_USERS')

GO

COMMIT TRAN
